# # -*- coding: utf-8 -*-
# """
# Created on Fri Apr 28 11:40:32 2023

# @author: 2020033001
# """
# # from zipline.pipeline import Pipeline, CustomFactor
from zipline.pipeline.data import Column, DataSet
from zipline.pipeline.domain import Domain,TW_EQUITIES
import os 
import json
# current directory
# module_dir = os.path.dirname(os.path.abspath(__file__))
# json_path = os.path.join(module_dir,'TQDataSet.json')

# Read JSON file
# with open(json_path, 'r') as json_file:
#     data = json.load(json_file)
#     json_file.close()

class TQDataSet(DataSet):
    domain = TW_EQUITIES
    symbol = Column(object)
    date = Column('datetime64[ns]')
    Dividend_Yield_TWSE = Column(float)
    Cash_Dividend_Yield_TEJ = Column(float)
    Adjust_Factor = Column(float)
    Transaction = Column(float)
    Common_Stock_Shares_Issued_Thousand_Shares = Column(float)
    PBR_TEJ = Column(float)
    Low = Column(float)
    PER_TWSE = Column(float)
    Adjust_Factor_Exclude_CashDiv = Column(float)
    Close = Column(float)
    Market_Cap_Percentage = Column(float)
    Open = Column(float)
    PBR_TWSE = Column(float)
    Last_Bid = Column(float)
    Value_Dollars = Column(float)
    High_Low_Diff = Column(float)
    Average_Trade_Price = Column(float)
    Trade_Value_Percentage = Column(float)
    High = Column(float)
    Listing_Type = Column(object)
    ROI = Column(float)
    Turnover = Column(float)
    PER_TEJ = Column(float)
    Last_Offer = Column(float)
    PSR_TEJ = Column(float)
    Market_Cap_Dollars = Column(float)
    Volume_1000_Shares = Column(float)
    Component_Stock_of_High_Dividend_Fg = Column(object)
    Matching_Period = Column(float)
    Industry = Column(object)
    Industry_Eng = Column(object)
    Sub_Industry = Column(object)  # 20231108
    Sub_Industry_Eng = Column(object) # 20231108
    Security_Type_English = Column(object)
    Component_Stock_of_MSCI_TW_Fg = Column(object)
    Suspended_Trading_Stock_Fg = Column(object)
    Attention_Stock_Fg = Column(object)
    Component_Stock_of_MidCap100_Fg = Column(object)
    Limit_Up_or_Down_in_Opening_Fg = Column(object)
    Market_Board = Column(object)
    Market_Board_Eng = Column(object)
    Security_Type_Chinese = Column(object)
    Suspension_of_Buy_After_Day_Trading_Fg = Column(object)
    Limit_Up_or_Down = Column(object)
    Component_Stock_of_TPEx200_Fg = Column(object)
    Disposition_Stock_Fg = Column(object)
    Full_Delivery_Stock_Fg = Column(object)
    Component_Stock_of_TPEx50_Fg = Column(object)
    Component_Stock_of_TWN50_Fg = Column(object)
    Dealer_Hedge_Diff_Amt = Column(float)
    Total_Sell_Amt = Column(float)
    Margin_Day_Trading_Amt = Column(float)
    Total_Buy_Vol = Column(float)
    Fund_Sell_Vol = Column(float)
    Fund_Stock_Holding_Pct = Column(float)
    Dealer_Proprietary_Diff_Vol = Column(float)
    Dealer_Proprietary_Sell_Vol = Column(float)
    Margin_Short_Balance_Vol = Column(float)
    Margin_Short_Maintenance_Ratio = Column(float)
    SBL_Short_Returns_Vol = Column(float)
    Fund_Buy_Vol = Column(float)
    SBL_Short_Balance_Amt = Column(float)
    Fund_Diff_Amt = Column(float)
    SBL_Short_Sales_Vol = Column(float)
    Qfii_Stock_Holding_Pct = Column(float)
    Fund_Diff_Vol = Column(float)
    Cash_Redemption = Column(float)
    Dealer_Hedge_Diff_Vol = Column(float)
    Dealer_Stock_Holding_Pct = Column(float)
    SBL_Short_Balance_Vol = Column(float)
    Fund_Sell_Amt = Column(float)
    Margin_Purchase = Column(float)
    Qfii_Diff_Vol = Column(float)
    Total_Buy_Amt = Column(float)
    Margin_Short_Balance_Amt = Column(float)
    Margin_Short_Sales = Column(float)
    Margin_Short_Quota = Column(float)
    SBL_Short_Quota = Column(float)
    Fund_Buy_Amt = Column(float)
    Margin_Day_Trading_Vol = Column(float)
    Total_Diff_Amt = Column(float)
    Total_Sell_Vol = Column(float)
    Dealer_Hedge_Buy_Vol = Column(float)
    Qfii_Sell_Amt = Column(float)
    Dealer_Hedge_Sell_Amt = Column(float)
    SBL_Short_Sales_Amt = Column(float)
    Dealer_Proprietary_Diff_Amt = Column(float)
    Margin_Maintenance_Ratio = Column(float)
    Qfii_Buy_Vol = Column(float)
    Dealer_Proprietary_Sell_Amt = Column(float)
    Dealer_Hedge_Buy_Amt = Column(float)
    Margin_Short_Coverting = Column(float)
    Day_Trading_Volume_1000_Shares = Column(float)
    Dealer_Proprietary_Buy_Amt = Column(float)
    Margin_Balance_Amt = Column(float)
    Qfii_Buy_Amt = Column(float)
    Qfii_Sell_Vol = Column(float)
    Margin_Stock_Redemtion = Column(float)
    Qfii_Diff_Amt = Column(float)
    Account_Maintenance_Ratio = Column(float)
    Margin_Quota = Column(float)
    Margin_Balance_Vol = Column(float)
    Margin_Balance_Ratio = Column(float)
    Total_Diff_Vol = Column(float)
    Day_Trading_Pct = Column(float)
    Margin_Sale = Column(float)
    Dealer_Proprietary_Buy_Vol = Column(float)
    Dealer_Hedge_Sell_Vol = Column(float)
    Custodied_Lots_Between_400_600_Pct = Column(float)
    Custodied_Larger_Than_400_Lots_Total_Lots = Column(float)
    Custodied_Greater_Than_1000_Lots_Total_Lots = Column(float)
    Custodied_Lots_Between_800_1000_Total_Holders = Column(float)
    Custodied_Lots_Between_600_800_Total_Holders = Column(float)
    Pledged_Stock_Shares_1000_Lots = Column(float)
    Custodied_Greater_Than_1000_Lots_Pct = Column(float)
    Custodied_Lots_Between_600_800_Pct = Column(float)
    Custodied_Lots_Between_800_1000_Total_Lots = Column(float)
    Total_Custodied_Shares_1000_Lots = Column(float)
    Custodied_Larger_Than_400_Lots_Total_Holders = Column(float)
    Custodied_Larger_Than_400_Lots_Pct = Column(float)
    Custodied_Under_400_Lots_Pct = Column(float)
    Custodied_Greater_Than_1000_Lots_Total_Holders = Column(float)
    Custodied_Under_400_Lots_Total_Holders = Column(float)
    Custodied_Lots_Between_800_1000_Pct = Column(float)
    Custodied_Lots_Between_600_800_Total_Lots = Column(float)
    Custodied_Under_400_Lots_Total_Lots = Column(float)
    Custodied_Lots_Between_400_600_Total_Lots = Column(float)
    Custodied_Lots_Between_400_600_Total_Holders = Column(float)
    Sales_Accu_LastYear = Column(float)
    Outstanding_Shares_1000_Shares = Column(float)
    MoM_Monthly_Sales = Column(float)
    Sales_Per_Share_Accu = Column(float)
    Month_Sales_Compared_To_Lowest_Month_Sales_MoM = Column(float)
    YoY_Accu_Sales_3M = Column(float)
    Lowest_Monthly_Sales_YM = Column('datetime64[ns]')
    YoY_AccuSales_12M = Column(float)
    Sales_Monthly = Column(float)
    MoM_Accu_Sales_3M = Column(float)
    Sales_Per_Share_Single_Month = Column(float)
    Highest_Or_Lowest_In_12M = Column(object)
    Hit_New_High_Or_Low_In_N_Months = Column(float)
    Sales_Per_Share_Accu_3M = Column(float)
    Sales_Accu_3M = Column(float)
    Highest_Or_Lowest_Same_Month = Column(object)
    Highest_Monthly_Sales_YM = Column('datetime64[ns]')
    Month_Sales_Compared_To_High_Month_Sales_MoM = Column(float)
    Lowest_Monthly_Sales = Column(float)
    Highest_Monthly_Sales = Column(float)
    Sales_Accu_3M_LastYear = Column(float)
    Sales_Accumulated = Column(float)
    YoY_Accu_Sales = Column(float)
    Sales_Accu_12M_Last_Year = Column(float)
    Sales_Accu_12M = Column(float)
    Sales_Per_Share_Accu_12M = Column(float)
    Highest_Or_Lowest_All_Time = Column(object)
    YoY_Monthly_Sales = Column(float)
    QoQ_Accu_Sales_3M = Column(float)
    Sales_Monthly_LastYear = Column(float)
    Operating_Income_Rate_percent_A = Column(float)
    Operating_Income_Rate_percent_Q = Column(float)
    Operating_Income_Rate_percent_TTM = Column(float)
    Gross_Margin_Growth_Rate_A = Column(float)
    Gross_Margin_Growth_Rate_Q = Column(float)
    Gross_Margin_Growth_Rate_TTM = Column(float)
    Net_Income_Loss_A = Column(float)
    Net_Income_Loss_Q = Column(float)
    Net_Income_Loss_TTM = Column(float)
    Pre_Tax_Income_Growth_Rate_A = Column(float)
    Pre_Tax_Income_Growth_Rate_Q = Column(float)
    Pre_Tax_Income_Growth_Rate_TTM = Column(float)
    Net_Operating_Income_Loss_A = Column(float)
    Net_Operating_Income_Loss_Q = Column(float)
    Net_Operating_Income_Loss_TTM = Column(float)
    Profit_Before_Tax_A = Column(float)
    Profit_Before_Tax_Q = Column(float)
    Profit_Before_Tax_TTM = Column(float)
    Net_Income_Rate_percent_A = Column(float)
    Net_Income_Rate_percent_Q = Column(float)
    Net_Income_Rate_percent_TTM = Column(float)
    Net_Income_Attributable_to_Parent_A = Column(float)
    Net_Income_Attributable_to_Parent_Q = Column(float)
    Net_Income_Attributable_to_Parent_TTM = Column(float)
    Operating_Income_Growth_Rate_A = Column(float)
    Operating_Income_Growth_Rate_Q = Column(float)
    Operating_Income_Growth_Rate_TTM = Column(float)
    Gross_Profit_Loss_from_Operations_A = Column(float)
    Gross_Profit_Loss_from_Operations_Q = Column(float)
    Gross_Profit_Loss_from_Operations_TTM = Column(float)
    Total_Operating_Income_A = Column(float)
    Total_Operating_Income_Q = Column(float)
    Total_Operating_Income_TTM = Column(float)
    Pre_Tax_Income_Rate_percent_A = Column(float)
    Pre_Tax_Income_Rate_percent_Q = Column(float)
    Pre_Tax_Income_Rate_percent_TTM = Column(float)
    Net_Income_Per_Share_A = Column(float)
    Net_Income_Per_Share_Q = Column(float)
    Net_Income_Per_Share_TTM = Column(float)
    Pre_Tax_Income_Per_Share_A = Column(float)
    Pre_Tax_Income_Per_Share_Q = Column(float)
    Pre_Tax_Income_Per_Share_TTM = Column(float)
    Basic_Earnings_Per_Share_A = Column(float)
    Basic_Earnings_Per_Share_Q = Column(float)
    Basic_Earnings_Per_Share_TTM = Column(float)
    Net_Income_Growth_Rate_A = Column(float)
    Net_Income_Growth_Rate_Q = Column(float)
    Net_Income_Growth_Rate_TTM = Column(float)
    Sales_Growth_Rate_A = Column(float)
    Sales_Growth_Rate_Q = Column(float)
    Sales_Growth_Rate_TTM = Column(float)
    Gross_Margin_Rate_percent_A = Column(float)
    Gross_Margin_Rate_percent_Q = Column(float)
    Gross_Margin_Rate_percent_TTM = Column(float)
    Total_Equity_A = Column(float)
    Total_Equity_Q = Column(float)
    Total_Equity_TTM = Column(float)
    Total_Non_Current_Assets_A = Column(float)
    Total_Non_Current_Assets_Q = Column(float)
    Total_Non_Current_Assets_TTM = Column(float)
    Advances_Receipts_Non_Current_A = Column(float)
    Advances_Receipts_Non_Current_Q = Column(float)
    Advances_Receipts_Non_Current_TTM = Column(float)
    Short_Term_Borrowings_Financial_Institutions_A = Column(float)
    Short_Term_Borrowings_Financial_Institutions_Q = Column(float)
    Short_Term_Borrowings_Financial_Institutions_TTM = Column(float)
    Long_Term_Borrowings_Financial_Institutions_A = Column(float)
    Long_Term_Borrowings_Financial_Institutions_Q = Column(float)
    Long_Term_Borrowings_Financial_Institutions_TTM = Column(float)
    Total_Non_current_Liabilities_A = Column(float)
    Total_Non_current_Liabilities_Q = Column(float)
    Total_Non_current_Liabilities_TTM = Column(float)
    Depreciable_Fixed_Assets_Growth_Rate_A = Column(float)
    Depreciable_Fixed_Assets_Growth_Rate_Q = Column(float)
    Depreciable_Fixed_Assets_Growth_Rate_TTM = Column(float)
    Total_Assets_Turnover_A = Column(float)
    Total_Assets_Turnover_Q = Column(float)
    Total_Assets_Turnover_TTM = Column(float)
    Total_Assets_A = Column(float)
    Total_Assets_Q = Column(float)
    Total_Assets_TTM = Column(float)
    Return_Rate_on_Equity_A_percent_A = Column(float)
    Return_Rate_on_Equity_A_percent_Q = Column(float)
    Return_Rate_on_Equity_A_percent_TTM = Column(float)
    Cash_Flow_from_Operating_Ratio_A = Column(float)
    Cash_Flow_from_Operating_Ratio_Q = Column(float)
    Cash_Flow_from_Operating_Ratio_TTM = Column(float)
    Days_Payables_Outstanding_A = Column(float)
    Days_Payables_Outstanding_Q = Column(float)
    Days_Payables_Outstanding_TTM = Column(float)
    Total_Retained_Earnings_A = Column(float)
    Total_Retained_Earnings_Q = Column(float)
    Total_Retained_Earnings_TTM = Column(float)
    Capital_Reserves_A = Column(float)
    Capital_Reserves_Q = Column(float)
    Capital_Reserves_TTM = Column(float)
    Accounts_Payable_Turnover_A = Column(float)
    Accounts_Payable_Turnover_Q = Column(float)
    Accounts_Payable_Turnover_TTM = Column(float)
    Cash_Flow_from_Investing_Activities_A = Column(float)
    Cash_Flow_from_Investing_Activities_Q = Column(float)
    Cash_Flow_from_Investing_Activities_TTM = Column(float)
    Non_Operating_Income_A = Column(float)
    Non_Operating_Income_Q = Column(float)
    Non_Operating_Income_TTM = Column(float)
    Prepayments_A = Column(float)
    Prepayments_Q = Column(float)
    Prepayments_TTM = Column(float)
    Accounts_Payable_A = Column(float)
    Accounts_Payable_Q = Column(float)
    Accounts_Payable_TTM = Column(float)
    Inventory_Turnover_A = Column(float)
    Inventory_Turnover_Q = Column(float)
    Inventory_Turnover_TTM = Column(float)
    Net_Non_operating_Income_Ratio_A = Column(float)
    Net_Non_operating_Income_Ratio_Q = Column(float)
    Net_Non_operating_Income_Ratio_TTM = Column(float)
    Other_Receivables_A = Column(float)
    Other_Receivables_Q = Column(float)
    Other_Receivables_TTM = Column(float)
    Days_Receivables_Outstanding_A = Column(float)
    Days_Receivables_Outstanding_Q = Column(float)
    Days_Receivables_Outstanding_TTM = Column(float)
    Recurring_Net_Income_A = Column(float)
    Recurring_Net_Income_Q = Column(float)
    Recurring_Net_Income_TTM = Column(float)
    Intangible_Assets_A = Column(float)
    Intangible_Assets_Q = Column(float)
    Intangible_Assets_TTM = Column(float)
    Common_Stocks_A = Column(float)
    Common_Stocks_Q = Column(float)
    Common_Stocks_TTM = Column(float)
    Common_Stock_Shares_Issued_Thousand_Shares_A = Column(float)
    Common_Stock_Shares_Issued_Thousand_Shares_Q = Column(float)
    Common_Stock_Shares_Issued_Thousand_Shares_TTM = Column(float)
    Short_Term_Borrowings_Non_Financial_Institutions_A = Column(float)
    Short_Term_Borrowings_Non_Financial_Institutions_Q = Column(float)
    Short_Term_Borrowings_Non_Financial_Institutions_TTM = Column(float)
    Liabilities_Ratio_A = Column(float)
    Liabilities_Ratio_Q = Column(float)
    Liabilities_Ratio_TTM = Column(float)
    Total_Current_Liabilities_A = Column(float)
    Total_Current_Liabilities_Q = Column(float)
    Total_Current_Liabilities_TTM = Column(float)
    Debt_Equity_Ratio_A = Column(float)
    Debt_Equity_Ratio_Q = Column(float)
    Debt_Equity_Ratio_TTM = Column(float)
    Current_Ratio_A = Column(float)
    Current_Ratio_Q = Column(float)
    Current_Ratio_TTM = Column(float)
    Interest_Expense_A = Column(float)
    Interest_Expense_Q = Column(float)
    Interest_Expense_TTM = Column(float)
    Inventories_A = Column(float)
    Inventories_Q = Column(float)
    Inventories_TTM = Column(float)
    Total_Liabilities_and_Equity_A = Column(float)
    Total_Liabilities_and_Equity_Q = Column(float)
    Total_Liabilities_and_Equity_TTM = Column(float)
    Sales_Per_Share_A = Column(float)
    Sales_Per_Share_Q = Column(float)
    Sales_Per_Share_TTM = Column(float)
    Non_Controlling_Interest_A = Column(float)
    Non_Controlling_Interest_Q = Column(float)
    Non_Controlling_Interest_TTM = Column(float)
    Long_Term_Accounts_Receivable_A = Column(float)
    Long_Term_Accounts_Receivable_Q = Column(float)
    Long_Term_Accounts_Receivable_TTM = Column(float)
    Number_of_Employees_A = Column(float)
    Number_of_Employees_Q = Column(float)
    Number_of_Employees_TTM = Column(float)
    Total_Equity_Growth_Rate_A = Column(float)
    Total_Equity_Growth_Rate_Q = Column(float)
    Total_Equity_Growth_Rate_TTM = Column(float)
    Total_Fixed_Assets_A = Column(float)
    Total_Fixed_Assets_Q = Column(float)
    Total_Fixed_Assets_TTM = Column(float)
    Quick_Assets_A = Column(float)
    Quick_Assets_Q = Column(float)
    Quick_Assets_TTM = Column(float)
    Fixed_Assets_A = Column(float)
    Fixed_Assets_Q = Column(float)
    Fixed_Assets_TTM = Column(float)
    Interest_Expense_Rate_percent_A = Column(float)
    Interest_Expense_Rate_percent_Q = Column(float)
    Interest_Expense_Rate_percent_TTM = Column(float)
    Total_Operating_Cost_A = Column(float)
    Total_Operating_Cost_Q = Column(float)
    Total_Operating_Cost_TTM = Column(float)
    Equity_Turnover_A = Column(float)
    Equity_Turnover_Q = Column(float)
    Equity_Turnover_TTM = Column(float)
    Taxrate_A = Column(float)
    Taxrate_Q = Column(float)
    Taxrate_TTM = Column(float)
    Other_Accounts_Payable_A = Column(float)
    Other_Accounts_Payable_Q = Column(float)
    Other_Accounts_Payable_TTM = Column(float)
    Accounts_Receivable_Current_and_Non_Current_A = Column(float)
    Accounts_Receivable_Current_and_Non_Current_Q = Column(float)
    Accounts_Receivable_Current_and_Non_Current_TTM = Column(float)
    Sales_Per_Employee_A = Column(float)
    Sales_Per_Employee_Q = Column(float)
    Sales_Per_Employee_TTM = Column(float)
    Total_Other_Equity_Interest_A = Column(float)
    Total_Other_Equity_Interest_Q = Column(float)
    Total_Other_Equity_Interest_TTM = Column(float)
    Non_Recurring_Net_Income_A = Column(float)
    Non_Recurring_Net_Income_Q = Column(float)
    Non_Recurring_Net_Income_TTM = Column(float)
    Operating_Expenses_Ratio_A = Column(float)
    Operating_Expenses_Ratio_Q = Column(float)
    Operating_Expenses_Ratio_TTM = Column(float)
    Income_Tax_Expense_A = Column(float)
    Income_Tax_Expense_Q = Column(float)
    Income_Tax_Expense_TTM = Column(float)
    Weighted_Average_Outstanding_Shares_Thousand_A = Column(float)
    Weighted_Average_Outstanding_Shares_Thousand_Q = Column(float)
    Weighted_Average_Outstanding_Shares_Thousand_TTM = Column(float)
    Preferred_Stock_Dividends_A = Column(float)
    Preferred_Stock_Dividends_Q = Column(float)
    Preferred_Stock_Dividends_TTM = Column(float)
    Times_Interest_Earned_A = Column(float)
    Times_Interest_Earned_Q = Column(float)
    Times_Interest_Earned_TTM = Column(float)
    Days_Inventory_Outstanding_A = Column(float)
    Days_Inventory_Outstanding_Q = Column(float)
    Days_Inventory_Outstanding_TTM = Column(float)
    Preferred_Stocks_A = Column(float)
    Preferred_Stocks_Q = Column(float)
    Preferred_Stocks_TTM = Column(float)
    Cash_Flow_from_Operating_Activities_A = Column(float)
    Cash_Flow_from_Operating_Activities_Q = Column(float)
    Cash_Flow_from_Operating_Activities_TTM = Column(float)
    Total_Current_Assets_A = Column(float)
    Total_Current_Assets_Q = Column(float)
    Total_Current_Assets_TTM = Column(float)
    Depreciation_and_Amortisation_A = Column(float)
    Depreciation_and_Amortisation_Q = Column(float)
    Depreciation_and_Amortisation_TTM = Column(float)
    Advances_Receipts_Current_A = Column(float)
    Advances_Receipts_Current_Q = Column(float)
    Advances_Receipts_Current_TTM = Column(float)
    Borrowings_A = Column(float)
    Borrowings_Q = Column(float)
    Borrowings_TTM = Column(float)
    Total_Liabilities_A = Column(float)
    Total_Liabilities_Q = Column(float)
    Total_Liabilities_TTM = Column(float)
    Total_Interest_Income_A = Column(float)
    Total_Interest_Income_Q = Column(float)
    Total_Interest_Income_TTM = Column(float)
    Accounts_Receivable_A = Column(float)
    Accounts_Receivable_Q = Column(float)
    Accounts_Receivable_TTM = Column(float)
    Accounts_Receivable_Turnover_A = Column(float)
    Accounts_Receivable_Turnover_Q = Column(float)
    Accounts_Receivable_Turnover_TTM = Column(float)
    Acid_Test_A = Column(float)
    Acid_Test_Q = Column(float)
    Acid_Test_TTM = Column(float)
    Total_Operating_Expenses_A = Column(float)
    Total_Operating_Expenses_Q = Column(float)
    Total_Operating_Expenses_TTM = Column(float)
    Cash_and_Cash_Equivalent_A = Column(float)
    Cash_and_Cash_Equivalent_Q = Column(float)
    Cash_and_Cash_Equivalent_TTM = Column(float)
    Operating_Income_Per_Share_A = Column(float)
    Operating_Income_Per_Share_Q = Column(float)
    Operating_Income_Per_Share_TTM = Column(float)
    Earnings_Before_Interest_and_Tax_A = Column(float)
    Earnings_Before_Interest_and_Tax_Q = Column(float)
    Earnings_Before_Interest_and_Tax_TTM = Column(float)
    Return_on_Total_Assets_A_percent_A = Column(float)
    Return_on_Total_Assets_A_percent_Q = Column(float)
    Return_on_Total_Assets_A_percent_TTM = Column(float)
    Fixed_Asset_Turnover_A = Column(float)
    Fixed_Asset_Turnover_Q = Column(float)
    Fixed_Asset_Turnover_TTM = Column(float)
    Long_Term_Borrowings_Non_Financial_Institutions_A = Column(float)
    Long_Term_Borrowings_Non_Financial_Institutions_Q = Column(float)
    Long_Term_Borrowings_Non_Financial_Institutions_TTM = Column(float)
    Cash_Flow_from_Financing_Activities_A = Column(float)
    Cash_Flow_from_Financing_Activities_Q = Column(float)
    Cash_Flow_from_Financing_Activities_TTM = Column(float)
    Book_Value_Per_Share_A_A = Column(float)
    Book_Value_Per_Share_A_Q = Column(float)
    Book_Value_Per_Share_A_TTM = Column(float)
    Total_Assets_Growth_Rate_A = Column(float)
    Total_Assets_Growth_Rate_Q = Column(float)
    Total_Assets_Growth_Rate_TTM = Column(float)
    
    domain = TW_EQUITIES
    # Top_10_Shareholder_Pledged_Shares_Percentage_Excluding_Directors_and_Supervisors = Column(float)
    # Manager_Holdings_Percentage = Column(float)
    # Major_Shareholder_Total_Pledged_Shares_TSE = Column(float)
    # Difference_Top_10_Shareholder_Total_Pledge_Shares_2 = Column(float)
    # Difference_in_Directors_and_Supervisors_Relatives_Holdings_Percentage_from_Previous_Period = Column(float)
    # Total_Director_Holdings_Percentage = Column(float)
    # Total_Director_and_Supervisor_Holdings = Column(float)
    # Recent_Election_Date = Column('datetime64[ns]')
    # Difference_in_Major_Shareholder_Total_Pledged_Shares_Percentage_TSE_from_Previous_Period = Column(float)
    # Difference_in_Supervisors_Relatives_Total_Holdings_from_Previous_Period = Column(float)
    # Election_Status = Column(object)
    # Supervisors_Relatives_Total_Holdings = Column(float)
    # Difference_in_Managers_Total_Holdings_Percentage_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Independent_Directors_Count = Column(float)
    # Difference_in_Directors_and_Supervisors_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Managers_Pledged_Shares_from_Previous_Period = Column(float)
    # Difference_in_Supervisors_Total_Holdings_Percentage_from_Previous_Period = Column(float)
    # Supervisors_Pledged_Shares = Column(float)
    # Difference_in_Directors_and_Supervisors_Relatives_Total_Pledged_Shares_from_Previous_Period = Column(float)
    # Executive_Directors_Count = Column(float)
    # Top_10_Shareholder_Pledged_Shares_Excluding_Directors_and_Supervisors = Column(float)
    # Difference_Top_10_Shareholder_Total_Pledge_Shares_Percentage_2 = Column(float)
    # Manager_Holdings_Including_Directors_and_Supervisors = Column(float)
    # Managers_Relatives_Total_Holdings_Including_Directors_and_Supervisors = Column(float)
    # Foreign_Independent_Directors_Count = Column(float)
    # Audit_Committee_Established = Column(object)
    # Difference_in_Managers_Total_Holdings_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Supervisors_Relatives_Holdings_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Supervisors_Relatives_Total_Pledged_Shares_from_Previous_Period = Column(float)
    # Difference_in_Major_Shareholder_Holdings_Percentage_TSE_from_Previous_Period = Column(float)
    # Difference_in_Supervisors_Pledged_Shares_from_Previous_Period = Column(float)
    # Difference_in_Major_Shareholder_Pledged_Shares_TSE_from_Previous_Period = Column(float)
    # Managers_Relatives_Total_Pledged_Shares = Column(float)
    # Difference_in_Managers_Total_Shares_from_Previous_Period = Column(float)
    # Director_Holdings = Column(float)
    # Managers_Total_Shares = Column(float)
    # Supervisors_Total_Pledged_Shares = Column(float)
    # Difference_in_Supervisor_Holdings_from_Previous_Period = Column(float)
    # Total_Director_Holdings = Column(float)
    # Top_10_Shareholder_Total_Pledged_Including_Rollover = Column(float)
    # Difference_in_Directors_and_Supervisors_Relatives_Total_Holdings_from_Previous_Period = Column(float)
    # Insufficient_Director_Shares = Column(object)
    # Major_Shareholder_Total_Pledged_Shares_1 = Column(float)
    # Directors_and_Supervisors_Total_Pledged_Shares = Column(float)
    # Top_10_Shareholder_Total_Pledged_Shares_Percentage_Including_Rollover = Column(float)
    # Top_10_Shareholder_Holdings_Excluding_Directors_and_Supervisors = Column(float)
    # Difference_in_Top_10_Shareholder_Total_Holdings_Excluding_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Major_Shareholder_Relatives_Holdings_Percentage_1_Excluding_Directors_and_Supervisors = Column(float)
    # General_Supervisors_Count = Column(float)
    # Difference_in_Total_Director_and_Supervisor_Holdings_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Managers_Relatives_Total_Pledged_Shares_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Difference_Major_Shareholder_Total_Pledged_Shares_1 = Column(float)
    # Supervisors_Pledged_Shares_Percentage = Column(float)
    # Difference_in_Managers_Pledged_Shares_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Difference_in_Directors_Total_Pledged_Shares_from_Previous_Period = Column(float)
    # Director_and_Supervisor_Holdings_Percentage = Column(float)
    # Difference_in_Top_10_Shareholder_Total_Holdings_Percentage_Excluding_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Difference_in_Managers_Relatives_Total_Pledged_Shares_from_Previous_Period = Column(float)
    # Major_Shareholder_Total_Pledged_Shares_Percentage_1 = Column(float)
    # Difference_in_Directors_Relatives_Total_Pledged_Shares_from_Previous_Period = Column(float)
    # Difference_in_Director_Holdings_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Directors_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Top_10_Shareholder_Total_Pledge_Shares_Percentage_2 = Column(float)
    # Directors_and_Supervisors_Relatives_Pledged_Shares_Percentage = Column(float)
    # Difference_in_Director_and_Supervisor_Holdings_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Directors_Pledged_Shares_from_Previous_Period = Column(float)
    # Difference_in_Managers_Relatives_Total_Holdings_from_Previous_Period = Column(float)
    # Top_10_Shareholder_Total_Holdings_Excluding_Directors_and_Supervisors = Column(float)
    # Difference_in_Supervisors_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Managers_Pledged_Shares_Percentage_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Chairman_Count = Column(float)
    # Difference_in_Director_Holdings_from_Previous_Period = Column(float)
    # Difference_in_Director_and_Supervisor_Holdings_from_Previous_Period = Column(float)
    # Difference_in_Total_Director_Holdings_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Directors_Relatives_Total_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Directors_Pledged_Shares_Percentage = Column(float)
    # Managers_Total_Pledged_Shares = Column(float)
    # Managers_Pledged_Shares_Including_Directors_and_Supervisors = Column(float)
    # Total_Directors_Count = Column(float)
    # Directors_Pledged_Shares = Column(float)
    # Directors_Total_Pledged_Shares_Percentage = Column(float)
    # Major_Shareholder_Holdings_TSE = Column(float)
    # Difference_in_Managers_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Managers_Total_Holdings_Percentage_Including_Directors_and_Supervisors = Column(float)
    # Difference_in_Major_Shareholder_Pledged_Shares_Percentage_TSE_from_Previous_Period = Column(float)
    # Difference_in_Total_Director_and_Supervisor_Holdings_from_Previous_Period = Column(float)
    # Difference_in_Top_10_Shareholder_Holdings_Percentage_Excluding_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Difference_in_Supervisors_Total_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Supervisors_Relatives_Pledged_Shares_Percentage_Percentage = Column(float)
    # Difference_in_Managers_Total_Pledged_Shares_Percentage_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Managers_Total_Pledged_Shares_Including_Directors_and_Supervisors = Column(float)
    # Difference_in_Major_Shareholder_Total_Pledged_Shares_TSE_from_Previous_Period = Column(float)
    # Supervisors_Relatives_Holdings_Percentage = Column(float)
    # Directors_Relatives_Holdings_Percentage = Column(float)
    # Supervisor_Holdings_Percentage = Column(float)
    # Difference_in_Manager_Holdings_from_Previous_Period = Column(float)
    # Total_Supervisor_Holdings = Column(float)
    # Difference_in_Directors_and_Supervisors_Total_Pledged_Shares_from_Previous_Period = Column(float)
    # Directors_Relatives_Total_Pledged_Shares = Column(float)
    # Difference_in_Major_Shareholder_Relatives_Total_Holdings_1_Excluding_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Difference_in_Managers_Relatives_Total_Holdings_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Executive_Supervisors_Count = Column(float)
    # Difference_in_Top_10_Shareholder_Pledged_Shares_Excluding_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Difference_in_Directors_Relatives_Holdings_Percentage_from_Previous_Period = Column(float)
    # Directors_and_Supervisors_Relatives_Total_Pledged_Shares = Column(float)
    # Difference_in_Manager_Holdings_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Major_Shareholder_Holdings_TSE_from_Previous_Period = Column(float)
    # Managers_Total_Pledged_Shares_Percentage = Column(float)
    # Difference_in_Supervisor_Holdings_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Major_Shareholder_Relatives_Holdings_Percentage_1_Excluding_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Manager_Holdings = Column(float)
    # Difference_in_Managers_Relatives_Pledged_Shares_Percentage_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Directors_and_Supervisors_Relatives_Total_Holdings = Column(float)
    # Difference_in_Total_Supervisor_Holdings_from_Previous_Period = Column(float)
    # Difference_in_Directors_and_Supervisors_Relatives_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Foreign_Directors_Count = Column(float)
    # Foreign_Independent_Supervisors_Count = Column(float)
    # Director_Holdings_Percentage = Column(float)
    # Managers_Relatives_Holdings_Percentage = Column(float)
    # Top_10_Shareholder_Total_Pledge_Shares_2 = Column(float)
    # Foreign_Supervisors_Count = Column(float)
    # Difference_in_Top_10_Shareholder_Pledged_Shares_Percentage_Excluding_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # General_Directors_Count = Column(float)
    # Difference_in_Managers_Total_Shares_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Difference_in_Directors_and_Supervisors_Total_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Supervisors_Total_Pledged_Shares_Percentage = Column(float)
    # Difference_in_Managers_Total_Pledged_Shares_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Major_Shareholder_Total_Holdings_Percentage_TSE = Column(float)
    # Difference_in_Top_10_Shareholder_Holdings_Excluding_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Directors_and_Supervisors_Pledged_Shares = Column(float)
    # Top_10_Shareholder_Holdings_Percentage_Excluding_Directors_and_Supervisors = Column(float)
    # Directors_and_Supervisors_Total_Pledged_Shares_Percentage = Column(float)
    # Major_Shareholder_Total_Pledged_Shares_Percentage_TSE = Column(float)
    # Difference_in_Major_Shareholder_Total_Holdings_Percentage_TSE_from_Previous_Period = Column(float)
    # Total_Director_and_Supervisor_Holdings_Percentage = Column(float)
    # Supervisor_Holdings = Column(float)
    # Major_Shareholder_Pledged_Shares_Percentage_TSE = Column(float)
    # Managers_Relatives_Total_Holdings = Column(float)
    # Managers_Relatives_Pledged_Shares_Percentage = Column(float)
    # Managers_Relatives_Total_Pledged_Shares_Including_Directors_and_Supervisors = Column(float)
    # Difference_in_Managers_Total_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Supervisors_Total_Pledged_Shares_from_Previous_Period = Column(float)
    # Insufficient_Supervisor_Shares = Column(object)
    # Independent_Supervisors_Count = Column(float)
    # Vice_Chairman_Count = Column(float)
    # Difference_in_Manager_Holdings_Percentage_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Directors_Relatives_Total_Pledged_Shares_Percentage = Column(float)
    # Managers_Pledged_Shares_Percentage = Column(float)
    # Managers_Total_Shares_Including_Directors_and_Supervisors = Column(float)
    # Manager_Holdings_Percentage_Including_Directors_and_Supervisors = Column(float)
    # Managers_Total_Pledged_Shares_Percentage_Including_Directors_and_Supervisors = Column(float)
    # Difference_in_Managers_Relatives_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Managers_Relatives_Holdings_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Managers_Total_Pledged_Shares_from_Previous_Period = Column(float)
    # Difference_in_Top_10_Shareholder_Relatives_Holdings_Percentage_2_Excluding_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Difference_in_Total_Director_Holdings_from_Previous_Period = Column(float)
    # Top_10_Shareholder_Total_Holdings_Percentage_Excluding_Directors_and_Supervisors = Column(float)
    # Directors_and_Supervisors_Relatives_Holdings_Percentage = Column(float)
    # Difference_in_Top_10_Shareholder_Relatives_Total_Holdings_2_Excluding_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Difference_in_Major_Shareholder_Total_Holdings_TSE_from_Previous_Period = Column(float)
    # Difference_in_Top_10_Shareholder_Total_Pledged_Shares_Percentage_Including_Rollover_from_Previous_Period = Column(float)
    # Difference_in_Supervisors_Relatives_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Difference_in_Manager_Holdings_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Difference_in_Directors_Relatives_Total_Holdings_from_Previous_Period = Column(float)
    # Major_Shareholder_Relatives_Total_Holdings_1_Excluding_Directors_and_Supervisors = Column(float)
    # Major_Shareholder_Total_Holdings_TSE = Column(float)
    # Major_Shareholder_Pledged_Shares_TSE = Column(float)
    # Managers_Total_Holdings_Percentage = Column(float)
    # Supervisors_Relatives_Total_Pledged_Shares = Column(float)
    # Total_Supervisors_Count = Column(float)
    # Director_and_Supervisor_Holdings = Column(float)
    # Next_Election_Date = Column('datetime64[ns]')
    # Directors_Total_Pledged_Shares = Column(float)
    # Managers_Pledged_Shares_Percentage_Including_Directors_and_Supervisors = Column(float)
    # Managers_Relatives_Holdings_Percentage_Including_Directors_and_Supervisors = Column(float)
    # Top_10_Shareholder_Relatives_Total_Holdings_2_Excluding_Directors_and_Supervisors = Column(float)
    # Difference_Major_Shareholder_Total_Pledge_Shares_Percentage_1 = Column(float)
    # Difference_in_Top_10_Shareholder_Total_Pledged_Shares_Including_Rollover_from_Previous_Period = Column(float)
    # Difference_in_Directors_and_Supervisors_Pledged_Shares_from_Previous_Period = Column(float)
    # Major_Shareholder_Holdings_Percentage_TSE = Column(float)
    # Difference_in_Directors_Total_Pledged_Shares_Percentage_from_Previous_Period = Column(float)
    # Managers_Pledged_Shares = Column(float)
    # Directors_Relatives_Total_Holdings = Column(float)
    # Top_10_Shareholder_Relatives_Holdings_Percentage_1_Excluding_Directors_and_Supervisors = Column(float)
    # Total_Shares = Column(float)
    # Difference_in_Managers_Relatives_Holdings_Percentage_Including_Directors_and_Supervisors_from_Previous_Period = Column(float)
    # Managers_Relatives_Pledged_Shares_Percentage_Including_Directors_and_Supervisors = Column(float)
    # Directors_and_Supervisors_Pledged_Shares_Percentage = Column(float)
    # Supervisors_Total_Holdings_Percentage = Column(float)
    # Old_Positions = Column(float)
    # Position_Change = Column(float)
    # New_Positions = Column(float)
    # New_Position_Change = Column(float)
    # Old_Position_Change = Column(float)
    # Position = Column(float)
    # Days_In_Position = Column(float)
    # Resignation_Date = Column('datetime64[ns]')
    # Name_En = Column(float)
    # Position_En = Column(float)
    # Payment_Securities_Type = Column(float)
    # Public_Acquisition_Shares = Column(float)
    # Merger_Event = Column(float)
    # Absorption_Merger_Type = Column(float)
    # Acquisition_and_Split_Item = Column(float)
    # Price_Per_Share = Column(float)
    # Public_Acquisition_End_Date = Column('datetime64[ns]')
    # Cash_Payment_Price_in_Currency = Column(float)
    # Acquisition_Target_Type = Column(float)
    # Main_Company_Exchange_for_Target_Shares = Column(float)
    # Defense_Measures_Taken = Column(float)
    # Extended_Public_Acquisition_End_Date = Column('datetime64[ns]')
    # Resolution_Method = Column(float)
    # Merger_Case_Name = Column(float)
    # Cash_Payment_Price_in_Original_Currency = Column(float)
    # Split_Type = Column(float)
    # Merger_Type = Column(float)
    # Public_Acquisition_Start_Date = Column('datetime64[ns]')
    # Exchange_Ratio_Maximum = Column(float)
    # Reference_Date = Column('datetime64[ns]')
    # Merger_Type_Horizontal_or_Vertical = Column(float)
    # Breakup_Reason = Column(float)
    # Shares = Column(float)
    # Minimum_Expected_Acquisition = Column(float)
    # Related_Party_Fg = Column(float)
    # Event_Data_Source = Column(float)
    # Stock_Payment_Price_in_Currency = Column(float)
    # ma_no = Column(float)
    # Maximum_Expected_Acquisition = Column(float)
    # Share_Acquisition_Method = Column(float)
    # Defense_Method = Column(float)
    # Relationship = Column(float)
    # Exchange_Ratio_Minimum = Column(float)
    # Price_Maximum = Column(float)
    # Price_Minimum = Column(float)
    # Target_Company_Name = Column(float)
    # News_Date = Column('datetime64[ns]')
    # Acquiring_Company_Name = Column(float)
    # Holdings_Percentage_After_Acquisition = Column(float)
    # Target_Company_Code = Column(float)
    # Total_Acquisition_Payment_in_Currency = Column(float)
    # Acquirer_Attitude = Column(float)
    # Breakup_Date = Column('datetime64[ns]')
    # Capital_Reserves_Rights_Issuance = Column(float)
    # Q2_Ex-Dividend_Date = Column('datetime64[ns]')
    # Q4_Dividend_Decision_Board_of_Directors = Column('datetime64[ns]')
    # Last_Dividend_Payment_Date = Column('datetime64[ns]')
    # Q3_Dividend_Payment_Date = Column('datetime64[ns]')
    # Q3_Dividend_Decision_Shareholders_Meeting = Column('datetime64[ns]')
    # Bonus_Issuance_Total = Column(float)
    # Q1_Dividend_Decision_Board_of_Directors = Column('datetime64[ns]')
    # Q4_Earnings_Distribution_Start_Date = Column('datetime64[ns]')
    # Q4_Dividend_Decision_Shareholders_Meeting = Column('datetime64[ns]')
    # Q1_Dividend_Decision_Shareholders_Meeting = Column('datetime64[ns]')
    # Cumulative_Cash_Dividend = Column(float)
    # Last_Ex-Dividend_Date = Column('datetime64[ns]')
    # Rights_Issuance_Date = Column('datetime64[ns]')
    # Q3_Dividend_Decision_Board_of_Directors = Column('datetime64[ns]')
    # Q2_Earnings_Distribution_Start_Date = Column('datetime64[ns]')
    # Q2_Cash_Dividend_TWD = Column(float)
    # Cumulative_Cash_Dividend_Capital_Reserves = Column(float)
    # Q2_Earnings_Distribution_End_Date = Column('datetime64[ns]')
    # Q4_Ex-Dividend_Announcement_Date = Column('datetime64[ns]')
    # Q2_Dividend_Decision_Shareholders_Meeting = Column('datetime64[ns]')
    # Q4_Earnings_Distribution_End_Date = Column('datetime64[ns]')
    # Dividend_Payout_Rate_Percentage = Column(float)
    # Q2_Dividend_Payment_Date = Column('datetime64[ns]')
    # Q2_Dividend_Decision_Board_of_Directors = Column('datetime64[ns]')
    # Q1_Ex-Dividend_Announcement_Date = Column('datetime64[ns]')
    # Q4_Cash_Dividend_TWD = Column(float)
    # Q1_Earnings_Distribution_End_Date = Column('datetime64[ns]')
    # Q4_Dividend_Payment_Date = Column('datetime64[ns]')
    # Earnings_Rights_Issuance = Column(float)
    # Q1_Dividend_Payment_Date = Column('datetime64[ns]')
    # Q3_Earnings_Distribution_End_Date = Column('datetime64[ns]')
    # Q1_Cash_Dividend_TWD = Column(float)
    # Cumulative_Cash_Dividend_Earnings = Column(float)
    # Q3_Cash_Dividend_TWD = Column(float)
    # Q3_Ex-Dividend_Date = Column('datetime64[ns]')
    # Dividend_Payment_Frequency = Column(float)
    # Q3_Earnings_Distribution_Start_Date = Column('datetime64[ns]')
    # Q4_Ex-Dividend_Date = Column('datetime64[ns]')
    # Q1_Ex-Dividend_Date = Column('datetime64[ns]')
    # Year-to-Date_Dividend_Is_Full_Year_Dividend _Fg = Column(object)
    # Q2_Ex-Dividend_Announcement_Date = Column('datetime64[ns]')
    # Q1_Earnings_Distribution_Start_Date = Column('datetime64[ns]')
    # Q3_Ex-Dividend_Announcement_Date = Column('datetime64[ns]')
    # Rights_Issuance_Accelerated_Payment_Start_Date = Column('datetime64[ns]')
    # Convertible_Shares_Total_Thousand_Shares = Column(float)
    # Total_Stock_Capital_Thousand_TWD = Column(float)
    # Convertible_Bonds_Conversion_Price_Per_Unit = Column(float)
    # Restricted_Employee_Rights_New_Stock_Cancellation_Thousand_Shares = Column(float)
    # Stock_Dividend_Announcement_Date = Column('datetime64[ns]')
    # Rights_Issuance_Flag _Fg = Column(object)
    # Employee_Rights_Issuance_Rate_Percentage = Column(float)
    # Ex-Rights_Reference_Price_Per_Unit = Column(float)
    # Par_Value = Column(float)
    # Rights_Issuance_Stock_Listing_Date = Column('datetime64[ns]')
    # Preferred_Shares_Securities_Conversion_Thousand_Shares = Column(float)
    # Cash_Capital_Increase_Thousand_Shares = Column(float)
    # Public_Underwriting_Rate_Percentage = Column(float)
    # Payment_Certificate_Announcement_Date = Column('datetime64[ns]')
    # Margin_Trading_Suspension_Start_Date = Column('datetime64[ns]')
    # Margin_Trading_Suspension_End_Date = Column('datetime64[ns]')
    # Margin_Trading_Last_Return_Date = Column('datetime64[ns]')
    # Board_of_Directors_Decision_Date = Column('datetime64[ns]')
    # Warrant_Release_Date = Column('datetime64[ns]')
    # Capital_Use = Column(object)
    # Convertible_Shares_Thousand_Shares = Column(float)
    # Other_Thousand_Shares = Column(float)
    # Cash_Subscription_Rate_Percentage = Column(float)
    # GDR_Rate_Percentage = Column(float)
    # Earnings_Rights_Issuance_Rate_Percentage = Column(float)
    # Suspension_Transfer_End_Date = Column('datetime64[ns]')
    # Treasury_Stock_Cancellation_Thousand_Shares = Column(float)
    # Stock_Dividend_Listing_Date = Column('datetime64[ns]')
    # Rights_Issuance_Stock_Announcement_Date = Column('datetime64[ns]')
    # Capital_Reserves_Capital_Increase_Thousand_Shares = Column(float)
    # Short_Selling_Suspension_Start_Date = Column('datetime64[ns]')
    # Total_Shares_Thousand_Shares = Column(float)
    # Original_Shareholder_Payment_End_Date = Column('datetime64[ns]')
    # Currency_capitaltable = Column(object)
    # Employee_Bonus_Thousand_Shares = Column(float)
    # Purchase_Rate_Percentage = Column(float)
    # Payment_Certificate_Listing_Date = Column('datetime64[ns]')
    # Cash_Back_Per_Share_After_Reduction = Column(float)
    # Capital_Increase_Announcement_Date = Column('datetime64[ns]')
    # Rights_Issuance_Stock_Release_Date = Column('datetime64[ns]')
    # Employee_Stock_Options_Thousand_Shares = Column(float)
    # Convertible_Bonds_Securities_Conversion_Thousand_Shares = Column(float)
    # Private_Placement_Flag _Fg = Column(object)
    # Other_Description = Column(object)
    # Employee_Subscription_Rate_Percentage = Column(float)
    # Warrant_Announcement_Date = Column('datetime64[ns]')
    # Private_Placement_Pricing_Date = Column('datetime64[ns]')
    # Original_Shareholder_Payment_Start_Date = Column('datetime64[ns]')
    # Cash_Capital_Increase_Failure_Flag = Column(object)
    # Capital_Reduction_Thousand_Shares = Column(float)
    # Capital_Increase_Failure_Reason = Column(object)
    # Employee_Bonus_Capital_Increase_Stock_Release_Date = Column('datetime64[ns]')
    # Securities_and_Futures_Bureau_Approval_Date = Column('datetime64[ns]')
    # Previous_Day_Closing_Price_Per_Unit = Column(float)
    # Cash_Subscription_Price_Per_Unit = Column(float)
    # Shareholders_Meeting_Decision_Date = Column('datetime64[ns]')
    # Warrant_Listing_Date = Column('datetime64[ns]')
    # Rights_Issuance_Accelerated_Payment_End_Date = Column('datetime64[ns]')
    # Merger_Thousand_Shares = Column(float)
    # Transfer_Thousand_Shares = Column(float)
    # IPO_Flag _Fg = Column(object)
    # Specific_Rate_Percentage = Column(float)
    # Employee_Bonus_Capital_Increase_Stock_Announcement_Date = Column('datetime64[ns]')
    # Payment_Certificate_Release_Date = Column('datetime64[ns]')
    # Last_Transfer_Date = Column('datetime64[ns]')
    # Capital_Reduction_Rate_Percentage = Column(float)
    # Capital_Reserves_Rights_Issuance_Rate_Percentage = Column(float)
    # Earnings_Capital_Increase_Thousand_Shares = Column(float)
    # Suspension_Transfer_Start_Date = Column('datetime64[ns]')
    # Employee_Bonus_Capital_Increase_Stock_Listing_Date = Column('datetime64[ns]')
    # Stock_Dividend_Release_Date = Column('datetime64[ns]')
    # Restricted_Employee_Rights_New_Stock_Thousand_Shares = Column(float)
    # Subscription_Price_Per_Unit = Column(float)
    # Subscriber_Name_English = Column(float)
    # Subscription_Shares_Thousand_Shares = Column(float)
    # Private_Placement_Period = Column(float)
    # Relationship_with_Company = Column(float)
    # Subscription_Amount_Thousand_TWD = Column(float)
    # Subscriber_Name = Column(float)
    # Shareholder_Name_Chinese_Intransfer = Column(object)
    # Original_Holding_Trust_Shares = Column(float)
    # Transferee_Name_Chinese = Column(object)
    # Declared_Transfer_Trust_Shares = Column(float)
    # Shareholder_Name_English_Intransfer = Column(object)
    # Shareholder_Identity_Chinese_Transfer = Column(object)
    # Trust_Shares_Declaration_Ratio = Column(float)
    # Shareholder_Identity_English_Transfer = Column(object)
    # Transfer_Method_Chinese = Column(object)
    # Declared_Transfer_Shares = Column(float)
    # Transfer_Start_Date = Column('datetime64[ns]')
    # Transfer_End_Date = Column('datetime64[ns]')
    # Transferee_Name_English = Column(object)
    # Original_Holding_Shares = Column(float)
    # Transfer_Method_English = Column(object)
    # Declaration_Ratio = Column(float)
    # Estimated_Transfer_Shares = Column(float)
    # tran_od = Column(float)
    # tran_nod = Column(float)
    # Untransferred_Date = Column('datetime64[ns]')
    # Actual_Transferred_Shares = Column(float)
    # Untransferred_Trust_Shares = Column(float)
    # Untransferred_Shares = Column(float)
    # Actual_Transferred_Trust_Shares = Column(float)
    # Untransferred_Reason_English = Column(float)
    # Untransferred_Reason_Chinese = Column(float)
    # Buyback_Period_Start_Date = Column('datetime64[ns]')
    # buyback_no = Column(float)
    # Event_Type_English = Column(float)
    # Cumulative_Holding_Shares = Column(float)
    # Buyback_Description_English = Column(float)
    # Buyback_Description_Chinese = Column(float)
    # Board_of_Directors_Decision_Cancellation_Date = Column('datetime64[ns]')
    # Total_Buyback_Price = Column(float)
    # Average_Buyback_Price = Column(float)
    # Buyback_Price_Range_Upper_Limit = Column(float)
    # Cumulative_Holding_Percentage = Column(float)
    # Event_Type_Chinese = Column(float)
    # Buyback_Price_Range_Lower_Limit = Column(float)
    # Buyback_Number = Column(float)
    # Buyback_Period_End_Date = Column('datetime64[ns]')
    # Announcement_Date = Column('datetime64[ns]')
    # TEJ_Industry_Name = Column(object)
    # English_Abbreviation = Column(object)
    # Initial_OTC_Listing_Date = Column('datetime64[ns]')
    # Initial_REG_Listing_Date = Column('datetime64[ns]')
    # Initial_TSE_Listing_Date = Column('datetime64[ns]')
    # Exchange_Industry_Code = Column(object)
    # English_Full_Name = Column(object)
    # Delisting_Date = Column('datetime64[ns]')
    # Exchange_Industry_Name = Column(object)
    # TEJ_Industry_Code = Column(object)
    # Latest_Listing_Date = Column('datetime64[ns]')
    # Unified_Identification_Number = Column(object)
    # Security_Full_Name = Column(object)
    # Security_Name = Column(object)
    # Security_Type = Column(object)`
    


# class TQDataSet(DataSet): 
    
#     Market=Column(object,missing_value=("")) #市場別
#     Open=Column(float) #開盤價
#     High=Column(float) #最高價
#     Low=Column(float) #最低價
#     Close=Column(float) #收盤價
#     Adjust_Factor=Column(float) #調整係數
#     Volume_1000_Shares=Column(float) #成交量_千股
#     Value_Dollars=Column(float) #成交金額_元
#     Transaction=Column(float) #成交筆數
#     Last_Bid=Column(float) #最後揭示買價
#     Last_Offer=Column(float) #最後揭示賣價
#     Average_Trade_Price=Column(float) #當日均價
#     ROI=Column(float) #報酬率
#     High_Low_Diff=Column(float) #高低價差
#     Turnover=Column(float) #周轉率
#     Issue_Shares_1000_Shares=Column(float) #流通在外股數_千股
#     Market_Cap_Dollars=Column(float) #個股市值_元
#     Market_Cap_Percentage=Column(float) #市值比重
#     Trade_Value_Percentage=Column(float) #成交金額比重
#     PER_TWSE=Column(float) #本益比
#     PBR_TWSE=Column(float) #股價淨值比
#     Dividend_Yield_TWSE=Column(float) #股利殖利率
#     Cash_Dividend_Yield_TEJ=Column(float) #現金股利率    
#     Adjust_Factor_Exclude_CashDiv=Column(float) #調整係數_除權
#     PER_TEJ = Column(float) # 本益比_TEJ
#     PBR_TEJ = Column(float) # 股價淨值比_TEJ
#     PSR_TEJ = Column(float) # 股價營收比_TEJ 
    
#     Sales_Monthly = Column(float) # 單月營收_千元
#     Sales_Monthly_LastYear = Column(float) # 去年單月營收_千元
#     YoY_Monthly_Sales = Column(float) # 單月營收成長率％
#     MoM_Monthly_Sales = Column(float) # 單月營收與上月比％
#     Sales_Accumulated = Column(float) # 累計營收_千元
#     Sales_Accu_LastYear = Column(float) # 去年累計營收_千元
#     YoY_Accu_Sales = Column(float) # 累計營收成長率％
#     Highest_Monthly_Sales = Column(float) # 歷史最高單月營收_千元
#     #Highest_Monthly_Sales_YM = Column(float) # 歷史最高單月營收_年月
#     Month_Sales_Compared_To_High_Month_Sales_MoM = Column(float) # 與歷史最高單月營收比%
#     Lowest_Monthly_Sales = Column(float) # 歷史最低單月營收_千元
#     #Lowest_Monthly_Sales_YM = Column(float) # 歷史最低單月營收_年月
#     Month_Sales_Compared_To_Lowest_Month_Sales_MoM = Column(float) # 與歷史最低單月營收比%
#     Highest_Or_Lowest_All_Time = Column(object,missing_value=(""))  # 創新高/低
#     Highest_Or_Lowest_In_12M = Column(object,missing_value=(""))  # 創新高/低_近一年
#     Highest_Or_Lowest_Same_Month = Column(object,missing_value=(""))  # 創新高/低_同月比較 
#     Hit_New_High_Or_Low_In_N_Months = Column(float) # 創 N月新高/低    
#     Sales_Accu_12M = Column(float) # 近12月累計營收_千元
#     Sales_Accu_12M_Last_Year = Column(float) # 去年近12月累計營收_千元
#     YoY_AccuSales_12M = Column(float) # 近12月累計營收成長率％
#     Sales_Accu_3M = Column(float) # 近 3月累計營收_千元
#     Sales_Accu_3M_LastYear = Column(float) # 去年近 3月累計營收_千元
#     YoY_Accu_Sales_3M = Column(float) # 近3月累計營收成長率％
#     MoM_Accu_Sales_3M = Column(float) # 近3月累計營收與上月比％    
#     QoQ_Accu_Sales_3M = Column(float) # 近3月累計營收變動率％
#     Outstanding_Shares_1000_Shares = Column(float) # 流通在外股數_千股
#     Sales_Per_Share_Single_Month = Column(float) # 單月每股營收_元
#     Sales_Per_Share_Accu = Column(float) # 累計每股營收_元
#     Sales_Per_Share_Accu_12M = Column(float) # 近12月每股營收_元
#     Sales_Per_Share_Accu_3M = Column(float) # 近 3月每股營收_元        
    
#     Qfii_Buy_Vol=Column(float) #外資買進張數
#     Qfii_Sell_Vol=Column(float) #外資賣出張數
#     Qfii_Diff_Vol=Column(float) #外資買賣超張數
#     Qfii_Buy_Amt=Column(float) #外資買進金額_元
#     Qfii_Sell_Amt=Column(float) #外資賣出金額_元
#     Qfii_Diff_Amt=Column(float) #外資買賣超金額_元
#     Qfii_Stock_Holding_Pct=Column(float) #外資持股率
#     Fund_Buy_Vol=Column(float) #投信買進張數
#     Fund_Sell_Vol=Column(float) #投信賣出張數
#     Fund_Diff_Vol=Column(float) #投信買賣超張數
#     Fund_Buy_Amt=Column(float) #投信買進金額_元
#     Fund_Sell_Amt=Column(float) #投信賣出金額_元
#     Fund_Diff_Amt=Column(float) #投信買賣超金額_元
#     Fund_Stock_Holding_Pct=Column(float) #投信持股率
#     Dealer_Proprietary_Buy_Vol=Column(float) #自營商買進張數_自行
#     Dealer_Proprietary_Sell_Vol=Column(float) #自營商賣出張數_自行
#     Dealer_Proprietary_Diff_Vol=Column(float) #自營買賣超張數_自行
#     Dealer_Proprietary_Buy_Amt=Column(float) #自營商買進金額_自行
#     Dealer_Proprietary_Sell_Amt=Column(float) #自營商賣出金額_自行
#     Dealer_Proprietary_Diff_Amt=Column(float) #自營買賣超金額_自行
#     Dealer_Hedge_Buy_Vol=Column(float) #自營商買進張數_避險
#     Dealer_Hedge_Sell_Vol=Column(float) #自營商賣出張數_避險
#     Dealer_Hedge_Diff_Vol=Column(float) #自營買賣超張數_避險
#     Dealer_Hedge_Buy_Amt=Column(float) #自營商買進金額_避險
#     Dealer_Hedge_Sell_Amt=Column(float) #自營商賣出金額_避險
#     Dealer_Hedge_Diff_Amt=Column(float) #自營買賣超金額_避險
#     Dealer_Stock_Holding_Pct=Column(float) #自營商持股率
#     Total_Buy_Vol=Column(float) #合計買進張數
#     Total_Sell_Vol=Column(float) #合計賣出張數
#     Total_Diff_Vol=Column(float) #合計買賣超張數     

#     Total_Buy_Amt=Column(float) #合計買進金額_元
#     Total_Sell_Amt=Column(float) #合計賣出金額_元
#     Total_Diff_Amt=Column(float) #合計買賣超金額_元   
    
#     Margin_Purchase=Column(float) #融資買進
#     Margin_Sale=Column(float) #融資賣出
#     Margin_Balance_Vol=Column(float) #融資餘額
#     Margin_Balance_Amt=Column(float) #融資餘額_元
#     Cash_Redemption=Column(float) #現金償還
#     Margin_Quota=Column(float) #融資限額
#     Margin_Short_Coverting=Column(float) #融券買進
#     Margin_Short_Sales=Column(float) #融券賣出
#     Margin_Short_Balance_Vol=Column(float) #融券餘額
#     Margin_Short_Balance_Amt=Column(float) #融券餘額_元
#     Margin_Stock_Redemtion=Column(float) #現券償還
#     Margin_Short_Quota=Column(float) #融券限額
#     Margin_Balance_Ratio=Column(float) #資券比
#     Margin_Day_Trading_Vol=Column(float) #資券互抵
#     Margin_Day_Trading_Amt=Column(float) #資券互抵_元
#     SBL_Short_Sales_Vol=Column(float) #借券賣出
#     SBL_Short_Sales_Amt=Column(float) #借券賣出_元
#     SBL_Short_Returns_Vol=Column(float) #當日還券
#     SBL_Short_Balance_Vol=Column(float) #借券餘額    
#     SBL_Short_Balance_Amt=Column(float) #借券餘額_元
#     SBL_Short_Quota=Column(float) #借券可使用額度
#     Margin_Maintenance_Ratio=Column(float) #融資維持率
#     Margin_Short_Maintenance_Ratio=Column(float) #融券維持率
#     Account_Maintenance_Ratio=Column(float) #整戶維持率
#     Day_Trading_Volume_1000_Shares=Column(float) #當沖成交股數_千股
#     Day_Trading_Pct=Column(float) #當沖買賣占比       
    
#     Total_Custodied_Shares_1000_Lots=Column(float) #集保庫存股數_千股
#     Total_Custodied_Shares_1000_Lots=Column(float) #集保庫存股數_千股
#     Pledged_Stock_Shares_1000_Lots=Column(float) #設質股數_千股
#     Custodied_Under_400_Lots_Total_Holders=Column(float) #未滿400張集保人數
#     Custodied_Under_400_Lots_Total_Lots=Column(float) #未滿400張集保張數
#     Custodied_Under_400_Lots_Pct=Column(float) #未滿400張集保占比
#     Custodied_Larger_Than_400_Lots_Total_Holders=Column(float) #超過400張集保人數
#     Custodied_Larger_Than_400_Lots_Total_Lots=Column(float) #超過400張集保張數
#     Custodied_Larger_Than_400_Lots_Pct=Column(float) #超過400張集保占比
#     Custodied_Lots_Between_400_600_Total_Holders=Column(float) #400-600張集保人數
#     Custodied_Lots_Between_400_600_Total_Lots=Column(float) #400-600張集保張數
#     Custodied_Lots_Between_400_600_Pct=Column(float) #400-600張集保占比
#     Custodied_Lots_Between_600_800_Total_Holders=Column(float) #600-800張集保人數
#     Custodied_Lots_Between_600_800_Total_Lots=Column(float) #600-800張集保張數
#     Custodied_Lots_Between_600_800_Pct=Column(float) #600-800張集保占比
#     Custodied_Lots_Between_800_1000_Total_Holders=Column(float) #800-1000張集保人數
#     Custodied_Lots_Between_800_1000_Total_Lots=Column(float) #800-1000張集保張數
#     Custodied_Lots_Between_800_1000_Pct=Column(float) #800-1000張集保占比
#     Custodied_Greater_Than_1000_Lots_Total_Holders=Column(float) #超過1000張集保人數
#     Custodied_Greater_Than_1000_Lots_Total_Lots=Column(float) #超過1000張集保張數
#     Custodied_Greater_Than_1000_Lots_Pct=Column(float) #超過1000張集保占比  
    
#     #industry_c = Column(object,missing_value=(""))  # 產業別_中文
#     Industry = Column(object,missing_value=(""))  # 產業別_中文
#     Industry_Eng = Column(object,missing_value=("")) # 產業別_英文
#     Attention_Stock_Fg = Column(object,missing_value=("")) # 是否為注意股票
#     Disposition_Stock_Fg = Column(object,missing_value=("")) # 是否為處置股票
#     Matching_Period = Column(object,missing_value=("")) # 分盤間隔時間
#     Suspended_Trading_Stock_Fg = Column(object,missing_value=("")) # 是否暫停交易
#     Full_Delivery_Stock_Fg = Column(object,missing_value=("")) # 是否全額交割
#     Limit_Up_or_Down = Column(object,missing_value=("")) # 漲跌停註記
#     Limit_Up_or_Down_in_Opening_Fg = Column(object,missing_value=("")) # 是否開盤即漲跌停
#     Suspension_of_Buy_After_Day_Trading_Fg = Column(object,missing_value=("")) # 暫停當沖先賣後買註記
#     Component_Stock_of_TWN50_Fg = Column(object,missing_value=("")) # 是否為臺灣50成分股
#     Component_Stock_of_MSCI_TW_Fg = Column(object,missing_value=("")) # 是否為MSCI成分股
#     Component_Stock_of_TPEx50_Fg = Column(object,missing_value=("")) # 是否為富櫃50成分股
#     Component_Stock_of_TPEx200_Fg = Column(object,missing_value=("")) # 是否為富櫃200成分股
#     Component_Stock_of_High_Dividend_Fg = Column(object,missing_value=("")) # 是否為高股息指數成分
#     Component_Stock_of_MidCap100_Fg = Column(object,missing_value=("")) # 是否為中型100成分股
#     Security_Type_Chinese = Column(object,missing_value=("")) # 證券種類(中)
#     Security_Type_English = Column(object,missing_value=("")) # 證券種類(英)
    
#     Cash_and_Cash_Equivalent=Column(float) #現金及約當現金
#     Deposit_interbank_funds=Column(float) #存放同業
#     Accounts_Receivable=Column(float) #應收帳款
#     Long_Term_Accounts_Receivable=Column(float) #長期應收款
#     Inventories=Column(float) #存貨
#     Accounts_Payable=Column(float) #應付帳款
#     Fixed_Assets=Column(float) #固定資產
#     Living_Assets=Column(float) #生物資產
#     Intangible_Assets=Column(float) #無形資產
#     Oil_and_Gas_Assets=Column(float) #油氣資產
#     Prepayments=Column(float) #預付款
#     Other_Receivables=Column(float) #其他應收款
#     Advances_Receipts_Current=Column(float) #預收款_流動
#     Other_Accounts_Payable=Column(float) #其他應付款
#     Advances_Receipts_Non_Current=Column(float) #預收款_非流動
#     Non_current_Assets_Classified_as_Held_for_Sale=Column(float) #待出售非流動資產
#     Liabilities_Included_in_Disposal_Groups_Classified_as_Held_for_Sale=Column(float) #待出售資產相關負債
#     Other_Current_Assets=Column(float) #其他營運流動資產
#     Other_Non_current_Assets=Column(float) #其他營運非流動資產
#     Other_Current_Liabilities=Column(float) #其他營運流動負債
#     Other_Non_current_Liabilities=Column(float) #其他營運非流動負債
#     Portfolio_of_Assets_Current=Column(float) #金融資產流動
#     Portfolio_of_Liabilities_Current=Column(float) #金融負債流動
#     Portfolio_of_Assets_Non_current=Column(float) #金融資產非流動
#     Portfolio_of_Liabilities_Non_current=Column(float) #金融負債非流動
#     Equity_Method_Investment=Column(float) #策略性投資
#     Property_Investments=Column(float) #投資性不動產
#     Financings_Provided_Current=Column(float) #資金貸與_流動
#     Financings_Provided_Non_current=Column(float) #資金貸與_非流動
#     Short_Term_Borrowings_Financial_Institutions=Column(float) #金融借款_流動
#     Long_Term_Borrowings_Financial_Institutions=Column(float) #金融借款_非流動
#     Short_Term_Borrowings_Non_financial_Institutions=Column(float) #非金融借款_流動
#     Long_Term_Borrowings_Non_financial_Institutions=Column(float) #非金融借款_非流動
#     Contingent_Liabilities=Column(float) #或有負債
#     Common_Stocks=Column(float) #普通股股本
#     Capital_Reserves=Column(float) #資本公積
#     Total_Retained_Earnings=Column(float) #保留盈餘
#     Preferred_Stocks=Column(float) #特別股股本      
#     Non_Controlling_Interest=Column(float) #非控制權益
#     Total_Other_Equity_Interest=Column(float) #其他權益
#     Total_Current_Assets=Column(float) #流動資產合計
#     Total_Non_current_Assets=Column(float) #非流動資產合計
#     Total_Assets=Column(float) #資產總計
#     Total_Current_Liabilities=Column(float) #流動負債合計
#     Total_Non_current_Liabilities=Column(float) #非流動負債合計
#     Total_Liabilities=Column(float) #負債總額
#     Total_Equity=Column(float) #股東權益總計
#     Total_Liabilities_and_Equity=Column(float) #負債及股東權益總計
#     Borrowings=Column(float) #長短期借款
    
#     Quick_Assets=Column(float) #速動資產
#     Total_Fixed_Assets=Column(float) #生財設備
#     Accounts_Receivable_Current_and_Non_Current=Column(float) #長短期應收帳款
#     Operating_Income=Column(float) #營業收入
#     Total_Operating_Income=Column(float) #營業總收入
#     Operating_Cost=Column(float) #營業成本
#     Total_Operating_Cost=Column(float) #營業總成本
#     Total_Operating_Expenses=Column(float) #營業費用
#     Gain_or_Loss_from_Disposal_of_Assets=Column(float) #處分資產損益
#     Impairment_Loss_Reversal_on_Property_Plant_and_Equipment=Column(float) #固定資產減損
#     Impairment_Loss_Reversal_on_Biological_Assets=Column(float) #生物資產減損
#     Impairment_Loss_Reversal_on_Oil_and_Gas_Assets=Column(float) #油氣資產減損    
#     Impairment_Loss_on_Intangible_Assets=Column(float) #無形資產減損
#     Income_Tax_Expense=Column(float) #所得稅
#     Other_Gain_or_Loss=Column(float) #其他營運損益
#     Other_Adjustment_Items=Column(float) #其他調整項
#     Gain_Loss_from_Subsidiary_Profit_before_Consolidated=Column(float) #合併方合併前淨利潤    
#     Gain_or_Loss_from_Exchange=Column(float) #匯兌損益
#     Gain_or_Loss_on_Valuation_of_Assets=Column(float) #評價損益    
#     Gain_or_Loss_from_Futures_and_Options=Column(float) #期權損益
#     Gain_or_Loss_on_Disposal_of_Equity_Method_Investments=Column(float)  #策略投資處分損益
#     Gain_or_Loss_on_Valuation_of_Equity_Method_Investments=Column(float)  #策略投資評價損益
#     Gain_or_Loss_on_Fixed_Interest_Investments=Column(float) #定息投資損益
#     Gain_or_Loss_on_other_Investments=Column(float) #其他投資損益
#     Investment_Gain_of_Loss_Equity_Method=Column(float) #策略投資權益法損益      
#     Total_Interest_Income=Column(float) #利息收入
#     Interest_Expense=Column(float) #利息支出
#     Capitalized_Interest=Column(float) #資本化利息支出     
#     Net_Income_Attributable_to_Non_Controlling_Interest=Column(float) #非控制權益損益
#     Operating_Profit=Column(float) #營業利潤
#     Profit_Before_Tax=Column(float) #利潤總額         
#     Net_Income_Loss = Column(float) #淨利潤
#     Net_Income_Attributable_to_Parent = Column(float) #母公司淨利
#     Basic_Earnings_Per_Share = Column(float) #母公司每股盈餘
#     Preferred_Stock_Dividends = Column(float) #特別股股息
#     Gross_Profit_Loss_from_Operations = Column(float) #毛利
#     Net_Operating_Income_Loss = Column(float) #營業利益
#     Non_Recurring_Net_Income = Column(float) #非常續性利益
#     Recurring_Net_Income = Column(float) #常續性利益
#     Non_Operating_Income = Column(float) #非營業利益
#     Earnings_Before_Interest_and_Tax = Column(float) #稅前息前淨利
#     Proceeds_from_Disposal_of_Fixed_and_Intangible_Assets = Column(float) #處分生財設備
#     Purchase_of_Fixed_and_Intangible_Assets = Column(float) #購買生財設備
#     Net_Income_Loss_CF = Column(float) #淨利潤_CF
#     Reversal_of_Allowance_for_Doubtful_Debts = Column(float) #提列呆帳
#     Reversal_of_Allowance_Inventory_Obsolescence = Column(float) #存貨跌價呆滯損失
#     Depreciation_and_Amortisation = Column(float) #折舊及攤提
#     Gain_or_Loss_from_Disposal_of_Assets_CF = Column(float) #處分生財設備損益_CF
#     Impairment_Loss_Reversal_on_Property_Plant_and_Equipment_CF = Column(float) #生財設備資產減損_CF
#     Decrease_Increase_in_Accounrs_Receivable = Column(float) #應收帳款增減
#     Decrease_Increase_in_Inventories = Column(float) #存貨增減
#     Increase_Decrease_in_Accounts_Payable = Column(float) #應付帳款增減
#     Decrease_Increase_in_Prepayments = Column(float) #預付款增減
#     Decrease_Increase_in_Other_Receivables = Column(float) #其他應收款增減
#     Increase_Decrease_in_Advances_Receipts = Column(float) #預收款增減
#     Increase_Decrease_in_Other_Accounts_Payable = Column(float) #其他應付款增減
#     Other_Adjustment_from_Operating_Activities = Column(float) #其他營運現金
#     Cash_Payment_of_Investment = Column(float) #支付投資現金
    
#     Proceeds_from_Disposal_of_Investment = Column(float) #收回投資現金
#     Cash_Flow_from_Acquisition_of_Equity_Method_Investment = Column(float) #新增策略性投資
#     Disposal_of_Equity_Method_Investment = Column(float) #處分策略性投資
#     Cash_Inflow_from_Financings_Provided = Column(float) #資金貸與現金流入
#     Cash_Outflow_from_Financings_Provided = Column(float) #資金貸與現金流出
#     Other_Adjustment_from_Investment_Activities = Column(float) #其他投資現金
#     Increase_in_Debt = Column(float) #借款現金流入
#     Debt_Redeemed = Column(float) #還款現金流出
#     Interest_Paid = Column(float) #分配股利或支付利息
#     Proceeds_from_Capital_Increase_Decrease = Column(float) #權益現金流入
#     Other_Adjustment_from_Financing_Activities = Column(float) #其他融資現金
#     Effect_of_Exchange_Rate_Changes_on_Cash_and_Cash_Equivalents = Column(float) #匯率影響數
#     Other_Cash_Equivalents_Increase_Decrease = Column(float) #其他影響數
#     Increase_Decrease_in_Cash_and_Cash_Equivalents = Column(float) #現金淨增加額
#     Cash_and_Cash_Equivalents_Beginning = Column(float) #期初現金及等價物淨額
#     Cash_Flow_from_Operating_Activities = Column(float) #營運產生現金流量
#     Cash_Flow_from_Investing_Activities = Column(float) #投資產生現金流量
#     Cash_Flow_from_Financing_Activities = Column(float) #融資產生現金流量
#     Cash_and_Cash_Equivalents_Ending = Column(float) #期末現金及等價物淨額
#     Number_of_Employees = Column(float) #員工人數
#     Common_Stock_Shares_Issued_Thousand_Shares = Column(float) #期末股數
#     Weighted_Average_Outstanding_Shares_Thousand = Column(float) #加權平均股數
#     Taxrate = Column(float) #稅率
#     Return_Rate_on_Equity_A_percent = Column(float) #常續ROE
#     Return_on_Total_Assets_A_percent = Column(float) #常續ROA
#     Gross_Margin_Rate_percent = Column(float) #營業毛利率
#     Operating_Income_Rate_percent = Column(float) #營業利益率
#     Pre_Tax_Income_Rate_percent = Column(float) #稅前淨利率
#     Net_Income_Rate_percent = Column(float) #稅後淨利率
#     Operating_Expenses_Ratio = Column(float) #營業費用率
#     Net_Non_operating_Income_Ratio = Column(float) #業外收支率
#     Sales_Growth_Rate = Column(float) #營收成長率
#     Gross_Margin_Growth_Rate = Column(float) #營業毛利成長率
#     Operating_Income_Growth_Rate = Column(float) #營業利益成長率
#     Pre_Tax_Income_Growth_Rate = Column(float) #稅前淨利成長率
#     Net_Income_Growth_Rate = Column(float) #稅後淨利成長率
#     Total_Assets_Growth_Rate = Column(float) #資產成長率 
#     Total_Equity_Growth_Rate = Column(float) #淨值成長率
#     Depreciable_Fixed_Assets_Growth_Rate = Column(float) #固定資產成長率
#     Acid_Test = Column(float) #速動比率
#     Current_Ratio = Column(float) #流動比率
#     Cash_Flow_from_Operating_Ratio = Column(float) #現金流量比率
#     Liabilities_Ratio = Column(float) #負債比率
#     Interest_Expense_Rate_percent = Column(float) #利息支出率
#     Times_Interest_Earned = Column(float) #利息保障倍數
#     Debt_Equity_Ratio = Column(float) #借款依存度
#     Accounts_Receivable_Turnover = Column(float) #應收帳款週轉率
#     Accounts_Payable_Turnover = Column(float) #應付帳款週轉率
#     Inventory_Turnover = Column(float) #存貨週轉率
#     Total_Assets_Turnover = Column(float) #總資產週轉率
#     Equity_Turnover = Column(float) #淨值週轉率
#     Fixed_Asset_Turnover = Column(float) #固定資產週轉率
#     Days_Receivables_Outstanding = Column(float) #期末收帳天數
#     Days_Payables_Outstanding = Column(float) #期末付帳天數
#     Days_Inventory_Outstanding = Column(float) #期末售貨天數
#     Net_Operating_Cycle = Column(float) #淨營業週期
#     Book_Value_Per_Share_A = Column(float) #每股淨值
#     Sales_Per_Share = Column(float) #每股營業收入
#     Operating_Income_Per_Share = Column(float) #每股營業利益
#     Pre_Tax_Income_Per_Share = Column(float) #每股稅前淨益
#     Net_Income_Per_Share = Column(float) #每股稅後淨利
#     Sales_Per_Employee = Column(float) #每人營收   
    
#     #--------------------------------------------------
#     # Q
#     Cash_and_Cash_Equivalent_Q=Column(float) #現金及約當現金
#     Deposit_interbank_funds_Q=Column(float) #存放同業
#     Accounts_Receivable_Q=Column(float) #應收帳款
#     Long_Term_Accounts_Receivable_Q=Column(float) #長期應收款
#     Inventories_Q=Column(float) #存貨
#     Accounts_Payable_Q=Column(float) #應付帳款
#     Fixed_Assets_Q=Column(float) #固定資產
#     Living_Assets_Q=Column(float) #生物資產
#     Intangible_Assets_Q=Column(float) #無形資產
#     Oil_and_Gas_Assets_Q=Column(float) #油氣資產
#     Prepayments_Q=Column(float) #預付款
#     Other_Receivables_Q=Column(float) #其他應收款
#     Advances_Receipts_Current_Q=Column(float) #預收款_流動
#     Other_Accounts_Payable_Q=Column(float) #其他應付款
#     Advances_Receipts_Non_Current_Q=Column(float) #預收款_非流動
#     Non_current_Assets_Classified_as_Held_for_Sale_Q=Column(float) #待出售非流動資產
#     Liabilities_Included_in_Disposal_Groups_Classified_as_Held_for_Sale_Q=Column(float) #待出售資產相關負債
#     Other_Current_Assets_Q=Column(float) #其他營運流動資產
#     Other_Non_current_Assets_Q=Column(float) #其他營運非流動資產
#     Other_Current_Liabilities_Q=Column(float) #其他營運流動負債
#     Other_Non_current_Liabilities_Q=Column(float) #其他營運非流動負債
#     Portfolio_of_Assets_Current_Q=Column(float) #金融資產流動
#     Portfolio_of_Liabilities_Current_Q=Column(float) #金融負債流動
#     Portfolio_of_Assets_Non_current_Q=Column(float) #金融資產非流動
#     Portfolio_of_Liabilities_Non_current_Q=Column(float) #金融負債非流動
#     Equity_Method_Investment_Q=Column(float) #策略性投資
#     Property_Investments_Q=Column(float) #投資性不動產
#     Financings_Provided_Current_Q=Column(float) #資金貸與_流動
#     Financings_Provided_Non_current_Q=Column(float) #資金貸與_非流動
#     Short_Term_Borrowings_Financial_Institutions_Q=Column(float) #金融借款_流動
#     Long_Term_Borrowings_Financial_Institutions_Q=Column(float) #金融借款_非流動
#     Short_Term_Borrowings_Non_financial_Institutions_Q=Column(float) #非金融借款_流動
#     Long_Term_Borrowings_Non_financial_Institutions_Q=Column(float) #非金融借款_非流動
#     Contingent_Liabilities_Q=Column(float) #或有負債
#     Common_Stocks_Q=Column(float) #普通股股本
#     Capital_Reserves_Q=Column(float) #資本公積
#     Total_Retained_Earnings_Q=Column(float) #保留盈餘
#     Preferred_Stocks_Q=Column(float) #特別股股本      
#     Non_Controlling_Interest_Q=Column(float) #非控制權益
#     Total_Other_Equity_Interest_Q=Column(float) #其他權益
#     Total_Current_Assets_Q=Column(float) #流動資產合計
#     Total_Non_current_Assets_Q=Column(float) #非流動資產合計
#     Total_Assets_Q=Column(float) #資產總計
#     Total_Current_Liabilities_Q=Column(float) #流動負債合計
#     Total_Non_current_Liabilities_Q=Column(float) #非流動負債合計
#     Total_Liabilities_Q=Column(float) #負債總額
#     Total_Equity_Q=Column(float) #股東權益總計
#     Total_Liabilities_and_Equity_Q=Column(float) #負債及股東權益總計
#     Borrowings_Q=Column(float) #長短期借款
#     Quick_Assets_Q=Column(float) #速動資產
#     Total_Fixed_Assets_Q=Column(float) #生財設備
#     Accounts_Receivable_Current_and_Non_Current_Q=Column(float) #長短期應收帳款
#     Operating_Income_Q=Column(float) #營業收入
#     Total_Operating_Income_Q=Column(float) #營業總收入
#     Operating_Cost_Q=Column(float) #營業成本
#     Total_Operating_Cost_Q=Column(float) #營業總成本
#     Total_Operating_Expenses_Q=Column(float) #營業費用
#     Gain_or_Loss_from_Disposal_of_Assets_Q=Column(float) #處分資產損益
#     Impairment_Loss_Reversal_on_Property_Plant_and_Equipment_Q=Column(float) #固定資產減損
#     Impairment_Loss_Reversal_on_Biological_Assets_Q=Column(float) #生物資產減損
#     Impairment_Loss_Reversal_on_Oil_and_Gas_Assets_Q=Column(float) #油氣資產減損    
#     Impairment_Loss_on_Intangible_Assets_Q=Column(float) #無形資產減損
#     Income_Tax_Expense_Q=Column(float) #所得稅
#     Other_Gain_or_Loss_Q=Column(float) #其他營運損益
#     Other_Adjustment_Items_Q=Column(float) #其他調整項
#     Gain_Loss_from_Subsidiary_Profit_before_Consolidated_Q=Column(float) #合併方合併前淨利潤    
#     Gain_or_Loss_from_Exchange_Q=Column(float) #匯兌損益
#     Gain_or_Loss_on_Valuation_of_Assets_Q=Column(float) #評價損益    
#     Gain_or_Loss_from_Futures_and_Options_Q=Column(float) #期權損益
#     Gain_or_Loss_on_Disposal_of_Equity_Method_Investments_Q=Column(float)  #策略投資處分損益
#     Gain_or_Loss_on_Valuation_of_Equity_Method_Investments_Q=Column(float)  #策略投資評價損益
#     Gain_or_Loss_on_Fixed_Interest_Investments_Q=Column(float) #定息投資損益
#     Gain_or_Loss_on_other_Investments_Q=Column(float) #其他投資損益
#     Investment_Gain_of_Loss_Equity_Method_Q=Column(float) #策略投資權益法損益      
#     Total_Interest_Income_Q=Column(float) #利息收入
#     Interest_Expense_Q=Column(float) #利息支出
#     Capitalized_Interest_Q=Column(float) #資本化利息支出     
#     Net_Income_Attributable_to_Non_Controlling_Interest_Q=Column(float) #非控制權益損益
#     Operating_Profit_Q=Column(float) #營業利潤
#     Profit_Before_Tax_Q=Column(float) #利潤總額         
#     Net_Income_Loss_Q = Column(float) #淨利潤
#     Net_Income_Attributable_to_Parent_Q = Column(float) #母公司淨利
#     Basic_Earnings_Per_Share_Q = Column(float) #母公司每股盈餘
#     Preferred_Stock_Dividends_Q = Column(float) #特別股股息
#     Gross_Profit_Loss_from_Operations_Q = Column(float) #毛利
#     Net_Operating_Income_Loss_Q = Column(float) #營業利益
#     Non_Recurring_Net_Income_Q = Column(float) #非常續性利益
#     Recurring_Net_Income_Q = Column(float) #常續性利益
#     Non_Operating_Income_Q = Column(float) #非營業利益
#     Earnings_Before_Interest_and_Tax_Q = Column(float) #稅前息前淨利
#     Proceeds_from_Disposal_of_Fixed_and_Intangible_Assets_Q = Column(float) #處分生財設備
#     Purchase_of_Fixed_and_Intangible_Assets_Q = Column(float) #購買生財設備
#     Net_Income_Loss_CF_Q = Column(float) #淨利潤_CF
#     Reversal_of_Allowance_for_Doubtful_Debts_Q = Column(float) #提列呆帳
#     Reversal_of_Allowance_Inventory_Obsolescence_Q = Column(float) #存貨跌價呆滯損失
#     Depreciation_and_Amortisation_Q = Column(float) #折舊及攤提
#     Gain_or_Loss_from_Disposal_of_Assets_CF_Q = Column(float) #處分生財設備損益_CF
#     Impairment_Loss_Reversal_on_Property_Plant_and_Equipment_CF_Q = Column(float) #生財設備資產減損_CF
#     Decrease_Increase_in_Accounrs_Receivable_Q = Column(float) #應收帳款增減
#     Decrease_Increase_in_Inventories_Q = Column(float) #存貨增減
#     Increase_Decrease_in_Accounts_Payable_Q = Column(float) #應付帳款增減
#     Decrease_Increase_in_Prepayments_Q = Column(float) #預付款增減
#     Decrease_Increase_in_Other_Receivables_Q = Column(float) #其他應收款增減
#     Increase_Decrease_in_Advances_Receipts_Q = Column(float) #預收款增減
#     Increase_Decrease_in_Other_Accounts_Payable_Q = Column(float) #其他應付款增減
#     Other_Adjustment_from_Operating_Activities_Q = Column(float) #其他營運現金
#     Cash_Payment_of_Investment_Q = Column(float) #支付投資現金
#     Proceeds_from_Disposal_of_Investment_Q = Column(float) #收回投資現金
#     Cash_Flow_from_Acquisition_of_Equity_Method_Investment_Q = Column(float) #新增策略性投資
#     Disposal_of_Equity_Method_Investment_Q = Column(float) #處分策略性投資
#     Cash_Inflow_from_Financings_Provided_Q = Column(float) #資金貸與現金流入    
#     Cash_Outflow_from_Financings_Provided_Q = Column(float) #資金貸與現金流出
#     Other_Adjustment_from_Investment_Activities_Q = Column(float) #其他投資現金
#     Increase_in_Debt_Q = Column(float) #借款現金流入
#     Debt_Redeemed_Q = Column(float) #還款現金流出
#     Interest_Paid_Q = Column(float) #分配股利或支付利息
#     Proceeds_from_Capital_Increase_Decrease_Q = Column(float) #權益現金流入
#     Other_Adjustment_from_Financing_Activities_Q = Column(float) #其他融資現金
#     Effect_of_Exchange_Rate_Changes_on_Cash_and_Cash_Equivalents_Q = Column(float) #匯率影響數
#     Other_Cash_Equivalents_Increase_Decrease_Q = Column(float) #其他影響數
#     Increase_Decrease_in_Cash_and_Cash_Equivalents_Q = Column(float) #現金淨增加額
#     Cash_and_Cash_Equivalents_Beginning_Q = Column(float) #期初現金及等價物淨額
#     Cash_Flow_from_Operating_Activities_Q = Column(float) #營運產生現金流量
#     Cash_Flow_from_Investing_Activities_Q = Column(float) #投資產生現金流量
#     Cash_Flow_from_Financing_Activities_Q = Column(float) #融資產生現金流量
#     Cash_and_Cash_Equivalents_Ending_Q = Column(float) #期末現金及等價物淨額
#     Number_of_Employees_Q = Column(float) #員工人數
#     Common_Stock_Shares_Issued_Thousand_Shares_Q = Column(float) #期末股數
#     Weighted_Average_Outstanding_Shares_Thousand_Q = Column(float) #加權平均股數
#     Taxrate_Q = Column(float) #稅率
#     Return_Rate_on_Equity_A_percent_Q = Column(float) #常續ROE
#     Return_on_Total_Assets_A_percent_Q = Column(float) #常續ROA
#     Gross_Margin_Rate_percent_Q = Column(float) #營業毛利率
#     Operating_Income_Rate_percent_Q = Column(float) #營業利益率
#     Pre_Tax_Income_Rate_percent_Q = Column(float) #稅前淨利率
#     Net_Income_Rate_percent_Q = Column(float) #稅後淨利率
#     Operating_Expenses_Ratio_Q = Column(float) #營業費用率
#     Net_Non_operating_Income_Ratio_Q = Column(float) #業外收支率
#     Sales_Growth_Rate_Q = Column(float) #營收成長率
#     Gross_Margin_Growth_Rate_Q = Column(float) #營業毛利成長率
#     Operating_Income_Growth_Rate_Q = Column(float) #營業利益成長率
#     Pre_Tax_Income_Growth_Rate_Q = Column(float) #稅前淨利成長率
#     Net_Income_Growth_Rate_Q = Column(float) #稅後淨利成長率
#     Total_Assets_Growth_Rate_Q = Column(float) #資產成長率   
#     Total_Equity_Growth_Rate_Q = Column(float) #淨值成長率
#     Depreciable_Fixed_Assets_Growth_Rate_Q = Column(float) #固定資產成長率
#     Acid_Test_Q = Column(float) #速動比率
#     Current_Ratio_Q = Column(float) #流動比率
#     Cash_Flow_from_Operating_Ratio_Q = Column(float) #現金流量比率
#     Liabilities_Ratio_Q = Column(float) #負債比率
#     Interest_Expense_Rate_percent_Q = Column(float) #利息支出率
#     Times_Interest_Earned_Q = Column(float) #利息保障倍數
#     Debt_Equity_Ratio_Q = Column(float) #借款依存度
#     Accounts_Receivable_Turnover_Q = Column(float) #應收帳款週轉率
#     Accounts_Payable_Turnover_Q = Column(float) #應付帳款週轉率
#     Inventory_Turnover_Q = Column(float) #存貨週轉率
#     Total_Assets_Turnover_Q = Column(float) #總資產週轉率
#     Equity_Turnover_Q = Column(float) #淨值週轉率
#     Fixed_Asset_Turnover_Q = Column(float) #固定資產週轉率
#     Days_Receivables_Outstanding_Q = Column(float) #期末收帳天數
#     Days_Payables_Outstanding_Q = Column(float) #期末付帳天數
#     Days_Inventory_Outstanding_Q = Column(float) #期末售貨天數
#     Net_Operating_Cycle_Q = Column(float) #淨營業週期
#     Book_Value_Per_Share_A_Q = Column(float) #每股淨值
#     Sales_Per_Share_Q = Column(float) #每股營業收入
#     Operating_Income_Per_Share_Q = Column(float) #每股營業利益
#     Pre_Tax_Income_Per_Share_Q = Column(float) #每股稅前淨益
#     Net_Income_Per_Share_Q = Column(float) #每股稅後淨利
#     Sales_Per_Employee_Q = Column(float) #每人營收
    
#     #--------------------------------------------------
#     # A
#     Cash_and_Cash_Equivalent_A = Column(float) #現金及約當現金
#     Deposit_interbank_funds_A = Column(float) #存放同業
#     Accounts_Receivable_A = Column(float) #應收帳款
#     Long_Term_Accounts_Receivable_A = Column(float) #長期應收款
#     Inventories_A = Column(float) #存貨
#     Accounts_Payable_A = Column(float) #應付帳款
#     Fixed_Assets_A = Column(float) #固定資產
#     Living_Assets_A = Column(float) #生物資產
#     Intangible_Assets_A = Column(float) #無形資產
#     Oil_and_Gas_Assets_A = Column(float) #油氣資產
#     Prepayments_A = Column(float) #預付款
#     Other_Receivables_A = Column(float) #其他應收款
#     Advances_Receipts_Current_A = Column(float) #預收款_流動
#     Other_Accounts_Payable_A = Column(float) #其他應付款
#     Advances_Receipts_Non_Current_A = Column(float) #預收款_非流動
#     Non_current_Assets_Classified_as_Held_for_Sale_A = Column(float) #待出售非流動資產
#     Liabilities_Included_in_Disposal_Groups_Classified_as_Held_for_Sale_A = Column(float) #待出售資產相關負債
#     Other_Current_Assets_A = Column(float) #其他營運流動資產
#     Other_Non_current_Assets_A = Column(float) #其他營運非流動資產
#     Other_Current_Liabilities_A = Column(float) #其他營運流動負債
#     Other_Non_current_Liabilities_A = Column(float) #其他營運非流動負債
#     Portfolio_of_Assets_Current_A = Column(float) #金融資產流動
#     Portfolio_of_Liabilities_Current_A = Column(float) #金融負債流動
#     Portfolio_of_Assets_Non_current_A = Column(float) #金融資產非流動
#     Portfolio_of_Liabilities_Non_current_A = Column(float) #金融負債非流動
#     Equity_Method_Investment_A = Column(float) #策略性投資
#     Property_Investments_A = Column(float) #投資性不動產
#     Financings_Provided_Current_A = Column(float) #資金貸與_流動
#     Financings_Provided_Non_current_A = Column(float) #資金貸與_非流動
#     Short_Term_Borrowings_Financial_Institutions_A = Column(float) #金融借款_流動
#     Long_Term_Borrowings_Financial_Institutions_A = Column(float) #金融借款_非流動
#     Short_Term_Borrowings_Non_financial_Institutions_A = Column(float) #非金融借款_流動
#     Long_Term_Borrowings_Non_financial_Institutions_A = Column(float) #非金融借款_非流動
#     Contingent_Liabilities_A = Column(float) #或有負債
#     Common_Stocks_A = Column(float) #普通股股本
#     Capital_Reserves_A = Column(float) #資本公積
#     Total_Retained_Earnings_A = Column(float) #保留盈餘
#     Preferred_Stocks_A = Column(float) #特別股股本      
#     Non_Controlling_Interest_A = Column(float) #非控制權益
#     Total_Other_Equity_Interest_A = Column(float) #其他權益
#     Total_Current_Assets_A = Column(float) #流動資產合計
#     Total_Non_current_Assets_A = Column(float) #非流動資產合計
#     Total_Assets_A = Column(float) #資產總計
#     Total_Current_Liabilities_A = Column(float) #流動負債合計
#     Total_Non_current_Liabilities_A = Column(float) #非流動負債合計
#     Total_Liabilities_A = Column(float) #負債總額
#     Total_Equity_A = Column(float) #股東權益總計
#     Total_Liabilities_and_Equity_A = Column(float) #負債及股東權益總計
#     Borrowings_A = Column(float)
#     Quick_Assets_A=Column(float) #速動資產
#     Total_Fixed_Assets_A=Column(float) #生財設備
#     Accounts_Receivable_Current_and_Non_Current_A=Column(float) #長短期應收帳款
#     Operating_Income_A=Column(float) #營業收入
#     Total_Operating_Income_A=Column(float) #營業總收入
#     Operating_Cost_A=Column(float) #營業成本
#     Total_Operating_Cost_A=Column(float) #營業總成本
#     Total_Operating_Expenses_A=Column(float) #營業費用
#     Gain_or_Loss_from_Disposal_of_Assets_A=Column(float) #處分資產損益
#     Impairment_Loss_Reversal_on_Property_Plant_and_Equipment_A=Column(float) #固定資產減損
#     Impairment_Loss_Reversal_on_Biological_Assets_A=Column(float) #生物資產減損
#     Impairment_Loss_Reversal_on_Oil_and_Gas_Assets_A=Column(float) #油氣資產減損    
#     Impairment_Loss_on_Intangible_Assets_A=Column(float) #無形資產減損
#     Income_Tax_Expense_A=Column(float) #所得稅
#     Other_Gain_or_Loss_A=Column(float) #其他營運損益
#     Other_Adjustment_Items_A=Column(float) #其他調整項
#     Gain_Loss_from_Subsidiary_Profit_before_Consolidated_A=Column(float) #合併方合併前淨利潤    
#     Gain_or_Loss_from_Exchange_A=Column(float) #匯兌損益
#     Gain_or_Loss_on_Valuation_of_Assets_A=Column(float) #評價損益    
#     Gain_or_Loss_from_Futures_and_Options_A=Column(float) #期權損益
#     Gain_or_Loss_on_Disposal_of_Equity_Method_Investments_A=Column(float)  #策略投資處分損益
#     Gain_or_Loss_on_Valuation_of_Equity_Method_Investments_A=Column(float)  #策略投資評價損益
#     Gain_or_Loss_on_Fixed_Interest_Investments_A=Column(float) #定息投資損益
#     Gain_or_Loss_on_other_Investments_A=Column(float) #其他投資損益
#     Investment_Gain_of_Loss_Equity_Method_A=Column(float) #策略投資權益法損益      
#     Total_Interest_Income_A=Column(float) #利息收入
#     Interest_Expense_A=Column(float) #利息支出
#     Capitalized_Interest_A=Column(float) #資本化利息支出     
#     Net_Income_Attributable_to_Non_Controlling_Interest_A=Column(float) #非控制權益損益
#     Operating_Profit_A=Column(float) #營業利潤
#     Profit_Before_Tax_A=Column(float) #利潤總額         
#     Net_Income_Loss_A = Column(float) #淨利潤
#     Net_Income_Attributable_to_Parent_A = Column(float) #母公司淨利
#     Basic_Earnings_Per_Share_A = Column(float) #母公司每股盈餘
#     Preferred_Stock_Dividends_A = Column(float) #特別股股息
#     Gross_Profit_Loss_from_Operations_A = Column(float) #毛利
#     Net_Operating_Income_Loss_A = Column(float) #營業利益
#     Non_Recurring_Net_Income_A = Column(float) #非常續性利益
#     Recurring_Net_Income_A = Column(float) #常續性利益
#     Non_Operating_Income_A = Column(float) #非營業利益
#     Earnings_Before_Interest_and_Tax_A = Column(float) #稅前息前淨利
#     Proceeds_from_Disposal_of_Fixed_and_Intangible_Assets_A = Column(float) #處分生財設備
#     Purchase_of_Fixed_and_Intangible_Assets_A = Column(float) #購買生財設備
#     Net_Income_Loss_CF_A = Column(float) #淨利潤_CF
#     Reversal_of_Allowance_for_Doubtful_Debts_A = Column(float) #提列呆帳
#     Reversal_of_Allowance_Inventory_Obsolescence_A = Column(float) #存貨跌價呆滯損失
#     Depreciation_and_Amortisation_A = Column(float) #折舊及攤提
#     Gain_or_Loss_from_Disposal_of_Assets_CF_A = Column(float) #處分生財設備損益_CF
#     Impairment_Loss_Reversal_on_Property_Plant_and_Equipment_CF_A = Column(float) #生財設備資產減損_CF
#     Decrease_Increase_in_Accounrs_Receivable_A = Column(float) #應收帳款增減
#     Decrease_Increase_in_Inventories_A = Column(float) #存貨增減
#     Increase_Decrease_in_Accounts_Payable_A = Column(float) #應付帳款增減
#     Decrease_Increase_in_Prepayments_A = Column(float) #預付款增減
#     Decrease_Increase_in_Other_Receivables_A = Column(float) #其他應收款增減
#     Increase_Decrease_in_Advances_Receipts_A = Column(float) #預收款增減
#     Increase_Decrease_in_Other_Accounts_Payable_A = Column(float) #其他應付款增減
#     Other_Adjustment_from_Operating_Activities_A = Column(float) #其他營運現金
#     Cash_Payment_of_Investment_A = Column(float) #支付投資現金
#     Proceeds_from_Disposal_of_Investment_A = Column(float) #收回投資現金
#     Cash_Flow_from_Acquisition_of_Equity_Method_Investment_A = Column(float) #新增策略性投資
    
#     Disposal_of_Equity_Method_Investment_A = Column(float) #處分策略性投資
#     Cash_Inflow_from_Financings_Provided_A = Column(float) #資金貸與現金流入
#     Cash_Outflow_from_Financings_Provided_A = Column(float) #資金貸與現金流出
#     Other_Adjustment_from_Investment_Activities_A = Column(float) #其他投資現金
#     Increase_in_Debt_A = Column(float) #借款現金流入
#     Debt_Redeemed_A = Column(float) #還款現金流出
#     Interest_Paid_A = Column(float) #分配股利或支付利息
#     Proceeds_from_Capital_Increase_Decrease_A = Column(float) #權益現金流入
#     Other_Adjustment_from_Financing_Activities_A = Column(float) #其他融資現金
#     Effect_of_Exchange_Rate_Changes_on_Cash_and_Cash_Equivalents_A = Column(float) #匯率影響數
#     Other_Cash_Equivalents_Increase_Decrease_A = Column(float) #其他影響數
#     Increase_Decrease_in_Cash_and_Cash_Equivalents_A = Column(float) #現金淨增加額
#     Cash_and_Cash_Equivalents_Beginning_A = Column(float) #期初現金及等價物淨額
#     Cash_Flow_from_Operating_Activities_A = Column(float) #營運產生現金流量
#     Cash_Flow_from_Investing_Activities_A = Column(float) #投資產生現金流量
#     Cash_Flow_from_Financing_Activities_A = Column(float) #融資產生現金流量
#     Cash_and_Cash_Equivalents_Ending_A = Column(float) #期末現金及等價物淨額
#     Number_of_Employees_A = Column(float) #員工人數
#     Common_Stock_Shares_Issued_Thousand_Shares_A = Column(float) #期末股數
#     Weighted_Average_Outstanding_Shares_Thousand_A = Column(float) #加權平均股數
#     Taxrate_A = Column(float) #稅率
#     Return_Rate_on_Equity_A_percent_A = Column(float) #常續ROE
#     Return_on_Total_Assets_A_percent_A = Column(float) #常續ROA
#     Gross_Margin_Rate_percent_A = Column(float) #營業毛利率
#     Operating_Income_Rate_percent_A = Column(float) #營業利益率
#     Pre_Tax_Income_Rate_percent_A = Column(float) #稅前淨利率
#     Net_Income_Rate_percent_A = Column(float) #稅後淨利率
#     Operating_Expenses_Ratio_A = Column(float) #營業費用率
#     Net_Non_operating_Income_Ratio_A = Column(float) #業外收支率
#     Sales_Growth_Rate_A = Column(float) #營收成長率
#     Gross_Margin_Growth_Rate_A = Column(float) #營業毛利成長率
#     Operating_Income_Growth_Rate_A = Column(float) #營業利益成長率
#     Pre_Tax_Income_Growth_Rate_A = Column(float) #稅前淨利成長率
#     Net_Income_Growth_Rate_A = Column(float) #稅後淨利成長率
#     Total_Assets_Growth_Rate_A = Column(float) #資產成長率 
#     Total_Equity_Growth_Rate_A = Column(float) #淨值成長率
#     Depreciable_Fixed_Assets_Growth_Rate_A = Column(float) #固定資產成長率
#     Acid_Test_A = Column(float) #速動比率
#     Current_Ratio_A = Column(float) #流動比率
#     Cash_Flow_from_Operating_Ratio_A = Column(float) #現金流量比率
#     Liabilities_Ratio_A = Column(float) #負債比率
#     Interest_Expense_Rate_percent_A = Column(float) #利息支出率
#     Times_Interest_Earned_A = Column(float) #利息保障倍數
#     Debt_Equity_Ratio_A = Column(float) #借款依存度
#     Accounts_Receivable_Turnover_A = Column(float) #應收帳款週轉率
#     Accounts_Payable_Turnover_A = Column(float) #應付帳款週轉率
#     Inventory_Turnover_A = Column(float) #存貨週轉率
#     Total_Assets_Turnover_A = Column(float) #總資產週轉率
#     Equity_Turnover_A = Column(float) #淨值週轉率
#     Fixed_Asset_Turnover_A = Column(float) #固定資產週轉率
#     Days_Receivables_Outstanding_A = Column(float) #期末收帳天數
#     Days_Payables_Outstanding_A = Column(float) #期末付帳天數
#     Days_Inventory_Outstanding_A = Column(float) #期末售貨天數
#     Net_Operating_Cycle_A = Column(float) #淨營業週期
#     Book_Value_Per_Share_A_A = Column(float) #每股淨值
#     Sales_Per_Share_A = Column(float) #每股營業收入
#     Operating_Income_Per_Share_A = Column(float) #每股營業利益
#     Pre_Tax_Income_Per_Share_A = Column(float) #每股稅前淨益
#     Net_Income_Per_Share_A = Column(float) #每股稅後淨利
#     Sales_Per_Employee_A = Column(float) #每人營收
    
#     #--------------------------------------------------
#     # TTM
#     Cash_and_Cash_Equivalent_TTM=Column(float) #現金及約當現金
#     Deposit_interbank_funds_TTM=Column(float) #存放同業
#     Accounts_Receivable_TTM=Column(float) #應收帳款
#     Long_Term_Accounts_Receivable_TTM=Column(float) #長期應收款
#     Inventories_TTM=Column(float) #存貨
#     Accounts_Payable_TTM=Column(float) #應付帳款
#     Fixed_Assets_TTM=Column(float) #固定資產
#     Living_Assets_TTM=Column(float) #生物資產
#     Intangible_Assets_TTM=Column(float) #無形資產
#     Oil_and_Gas_Assets_TTM=Column(float) #油氣資產
#     Prepayments_TTM=Column(float) #預付款
#     Other_Receivables_TTM=Column(float) #其他應收款
#     Advances_Receipts_Current_TTM=Column(float) #預收款_流動
#     Other_Accounts_Payable_TTM=Column(float) #其他應付款
#     Advances_Receipts_Non_Current_TTM=Column(float) #預收款_非流動
#     Non_current_Assets_Classified_as_Held_for_Sale_TTM=Column(float) #待出售非流動資產
#     Liabilities_Included_in_Disposal_Groups_Classified_as_Held_for_Sale_TTM=Column(float) #待出售資產相關負債
#     Other_Current_Assets_TTM=Column(float) #其他營運流動資產
#     Other_Non_current_Assets_TTM=Column(float) #其他營運非流動資產
#     Other_Current_Liabilities_TTM=Column(float) #其他營運流動負債
#     Other_Non_current_Liabilities_TTM=Column(float) #其他營運非流動負債
#     Portfolio_of_Assets_Current_TTM=Column(float) #金融資產流動
#     Portfolio_of_Liabilities_Current_TTM=Column(float) #金融負債流動
#     Portfolio_of_Assets_Non_current_TTM=Column(float) #金融資產非流動
#     Portfolio_of_Liabilities_Non_current_TTM=Column(float) #金融負債非流動
#     Equity_Method_Investment_TTM=Column(float) #策略性投資
#     Property_Investments_TTM=Column(float) #投資性不動產
#     Financings_Provided_Current_TTM=Column(float) #資金貸與_流動
#     Financings_Provided_Non_current_TTM=Column(float) #資金貸與_非流動
#     Short_Term_Borrowings_Financial_Institutions_TTM=Column(float) #金融借款_流動
#     Long_Term_Borrowings_Financial_Institutions_TTM=Column(float) #金融借款_非流動
#     Short_Term_Borrowings_Non_financial_Institutions_TTM=Column(float) #非金融借款_流動
#     Long_Term_Borrowings_Non_financial_Institutions_TTM=Column(float) #非金融借款_非流動
#     Contingent_Liabilities_TTM=Column(float) #或有負債
#     Common_Stocks_TTM=Column(float) #普通股股本
#     Capital_Reserves_TTM=Column(float) #資本公積
#     Total_Retained_Earnings_TTM=Column(float) #保留盈餘
#     Preferred_Stocks_TTM=Column(float) #特別股股本      
#     Non_Controlling_Interest_TTM=Column(float) #非控制權益
#     Total_Other_Equity_Interest_TTM=Column(float) #其他權益
#     Total_Current_Assets_TTM=Column(float) #流動資產合計
#     Total_Non_current_Assets_TTM=Column(float) #非流動資產合計
#     Total_Assets_TTM=Column(float) #資產總計
#     Total_Current_Liabilities_TTM=Column(float) #流動負債合計
#     Total_Non_current_Liabilities_TTM=Column(float) #非流動負債合計
#     Total_Liabilities_TTM=Column(float) #負債總額
#     Total_Equity_TTM=Column(float) #股東權益總計
#     Total_Liabilities_and_Equity_TTM=Column(float) #負債及股東權益總計
#     Borrowings_TTM=Column(float) #長短期借款

#     Quick_Assets_TTM=Column(float) #速動資產
#     Total_Fixed_Assets_TTM=Column(float) #生財設備
#     Accounts_Receivable_Current_and_Non_Current_TTM=Column(float) #長短期應收帳款
#     Operating_Income_TTM=Column(float) #營業收入
#     Total_Operating_Income_TTM=Column(float) #營業總收入
#     Operating_Cost_TTM=Column(float) #營業成本
#     Total_Operating_Cost_TTM=Column(float) #營業總成本
#     Total_Operating_Expenses_TTM=Column(float) #營業費用
#     Gain_or_Loss_from_Disposal_of_Assets_TTM=Column(float) #處分資產損益
#     Impairment_Loss_Reversal_on_Property_Plant_and_Equipment_TTM=Column(float) #固定資產減損
#     Impairment_Loss_Reversal_on_Biological_Assets_TTM=Column(float) #生物資產減損
#     Impairment_Loss_Reversal_on_Oil_and_Gas_Assets_TTM=Column(float) #油氣資產減損    
#     Impairment_Loss_on_Intangible_Assets_TTM=Column(float) #無形資產減損
#     Income_Tax_Expense_TTM=Column(float) #所得稅
#     Other_Gain_or_Loss_TTM=Column(float) #其他營運損益
#     Other_Adjustment_Items_TTM=Column(float) #其他調整項
#     Gain_Loss_from_Subsidiary_Profit_before_Consolidated_TTM=Column(float) #合併方合併前淨利潤    
#     Gain_or_Loss_from_Exchange_TTM=Column(float) #匯兌損益
#     Gain_or_Loss_on_Valuation_of_Assets_TTM=Column(float) #評價損益    
#     Gain_or_Loss_from_Futures_and_Options_TTM=Column(float) #期權損益
#     Gain_or_Loss_on_Disposal_of_Equity_Method_Investments_TTM=Column(float)  #策略投資處分損益
#     Gain_or_Loss_on_Valuation_of_Equity_Method_Investments_TTM=Column(float)  #策略投資評價損益
#     Gain_or_Loss_on_Fixed_Interest_Investments_TTM=Column(float) #定息投資損益
#     Gain_or_Loss_on_other_Investments_TTM=Column(float) #其他投資損益
#     Investment_Gain_of_Loss_Equity_Method_TTM=Column(float) #策略投資權益法損益      
#     Total_Interest_Income_TTM=Column(float) #利息收入
#     Interest_Expense_TTM=Column(float) #利息支出
#     Capitalized_Interest_TTM=Column(float) #資本化利息支出     
#     Net_Income_Attributable_to_Non_Controlling_Interest_TTM=Column(float) #非控制權益損益
#     Operating_Profit_TTM=Column(float) #營業利潤
#     Profit_Before_Tax_TTM=Column(float) #利潤總額         
#     Net_Income_Loss_TTM = Column(float) #淨利潤
#     Net_Income_Attributable_to_Parent_TTM = Column(float) #母公司淨利
#     Basic_Earnings_Per_Share_TTM = Column(float) #母公司每股盈餘
#     Preferred_Stock_Dividends_TTM = Column(float) #特別股股息
#     Gross_Profit_Loss_from_Operations_TTM = Column(float) #毛利
#     Net_Operating_Income_Loss_TTM = Column(float) #營業利益
#     Non_Recurring_Net_Income_TTM = Column(float) #非常續性利益
#     Recurring_Net_Income_TTM = Column(float) #常續性利益
#     Non_Operating_Income_TTM = Column(float) #非營業利益
#     Earnings_Before_Interest_and_Tax_TTM = Column(float) #稅前息前淨利
#     Proceeds_from_Disposal_of_Fixed_and_Intangible_Assets_TTM = Column(float) #處分生財設備
#     Purchase_of_Fixed_and_Intangible_Assets_TTM = Column(float) #購買生財設備
#     Net_Income_Loss_CF_TTM = Column(float) #淨利潤_CF
#     Reversal_of_Allowance_for_Doubtful_Debts_TTM = Column(float) #提列呆帳
#     Reversal_of_Allowance_Inventory_Obsolescence_TTM = Column(float) #存貨跌價呆滯損失
#     Depreciation_and_Amortisation_TTM = Column(float) #折舊及攤提
#     Gain_or_Loss_from_Disposal_of_Assets_CF_TTM = Column(float) #處分生財設備損益_CF
#     Impairment_Loss_Reversal_on_Property_Plant_and_Equipment_CF_TTM = Column(float) #生財設備資產減損_CF
#     Decrease_Increase_in_Accounrs_Receivable_TTM = Column(float) #應收帳款增減
#     Decrease_Increase_in_Inventories_TTM = Column(float) #存貨增減
#     Increase_Decrease_in_Accounts_Payable_TTM = Column(float) #應付帳款增減
#     Decrease_Increase_in_Prepayments_TTM = Column(float) #預付款增減
#     Decrease_Increase_in_Other_Receivables_TTM = Column(float) #其他應收款增減
#     Increase_Decrease_in_Advances_Receipts_TTM = Column(float) #預收款增減
#     Increase_Decrease_in_Other_Accounts_Payable_TTM = Column(float) #其他應付款增減    
#     Other_Adjustment_from_Operating_Activities_TTM = Column(float) #其他營運現金
#     Cash_Payment_of_Investment_TTM = Column(float) #支付投資現金    
    
#     Proceeds_from_Disposal_of_Investment_TTM = Column(float) #收回投資現金
#     Cash_Flow_from_Acquisition_of_Equity_Method_Investment_TTM = Column(float) #新增策略性投資
#     Disposal_of_Equity_Method_Investment_TTM = Column(float) #處分策略性投資
#     Cash_Inflow_from_Financings_Provided_TTM = Column(float) #資金貸與現金流入
#     Cash_Outflow_from_Financings_Provided_TTM = Column(float) #資金貸與現金流出
#     Other_Adjustment_from_Investment_Activities_TTM = Column(float) #其他投資現金
#     Increase_in_Debt_TTM = Column(float) #借款現金流入
#     Debt_Redeemed_TTM = Column(float) #還款現金流出
#     Interest_Paid_TTM = Column(float) #分配股利或支付利息
#     Proceeds_from_Capital_Increase_Decrease_TTM = Column(float) #權益現金流入
#     Other_Adjustment_from_Financing_Activities_TTM = Column(float) #其他融資現金
#     Effect_of_Exchange_Rate_Changes_on_Cash_and_Cash_Equivalents_TTM = Column(float) #匯率影響數
#     Other_Cash_Equivalents_Increase_Decrease_TTM = Column(float) #其他影響數
#     Increase_Decrease_in_Cash_and_Cash_Equivalents_TTM = Column(float) #現金淨增加額
#     Cash_and_Cash_Equivalents_Beginning_TTM = Column(float) #期初現金及等價物淨額
#     Cash_Flow_from_Operating_Activities_TTM = Column(float) #營運產生現金流量
#     Cash_Flow_from_Investing_Activities_TTM = Column(float) #投資產生現金流量
#     Cash_Flow_from_Financing_Activities_TTM = Column(float) #融資產生現金流量
#     Cash_and_Cash_Equivalents_Ending_TTM = Column(float) #期末現金及等價物淨額
#     Number_of_Employees_TTM = Column(float) #員工人數
#     Common_Stock_Shares_Issued_Thousand_Shares_TTM = Column(float) #期末股數
#     Weighted_Average_Outstanding_Shares_Thousand_TTM = Column(float) #加權平均股數
#     Taxrate_TTM = Column(float) #稅率
#     Return_Rate_on_Equity_A_percent_TTM = Column(float) #常續ROE
#     Return_on_Total_Assets_A_percent_TTM = Column(float) #常續ROA
#     Gross_Margin_Rate_percent_TTM = Column(float) #營業毛利率
#     Operating_Income_Rate_percent_TTM = Column(float) #營業利益率
#     Pre_Tax_Income_Rate_percent_TTM = Column(float) #稅前淨利率
#     Net_Income_Rate_percent_TTM = Column(float) #稅後淨利率
#     Operating_Expenses_Ratio_TTM = Column(float) #營業費用率
#     Net_Non_operating_Income_Ratio_TTM = Column(float) #業外收支率
#     Sales_Growth_Rate_TTM = Column(float) #營收成長率
#     Gross_Margin_Growth_Rate_TTM = Column(float) #營業毛利成長率
#     Operating_Income_Growth_Rate_TTM = Column(float) #營業利益成長率
#     Pre_Tax_Income_Growth_Rate_TTM = Column(float) #稅前淨利成長率
#     Net_Income_Growth_Rate_TTM = Column(float) #稅後淨利成長率
#     Total_Assets_Growth_Rate_TTM = Column(float) #資產成長率 
#     Total_Equity_Growth_Rate_TTM = Column(float) #淨值成長率
#     Depreciable_Fixed_Assets_Growth_Rate_TTM = Column(float) #固定資產成長率
#     Acid_Test_TTM = Column(float) #速動比率
#     Current_Ratio_TTM = Column(float) #流動比率
#     Cash_Flow_from_Operating_Ratio_TTM = Column(float) #現金流量比率
#     Liabilities_Ratio_TTM = Column(float) #負債比率
#     Interest_Expense_Rate_percent_TTM = Column(float) #利息支出率
#     Times_Interest_Earned_TTM = Column(float) #利息保障倍數
#     Debt_Equity_Ratio_TTM = Column(float) #借款依存度
#     Accounts_Receivable_Turnover_TTM = Column(float) #應收帳款週轉率
#     Accounts_Payable_Turnover_TTM = Column(float) #應付帳款週轉率
#     Inventory_Turnover_TTM = Column(float) #存貨週轉率
#     Total_Assets_Turnover_TTM = Column(float) #總資產週轉率
#     Equity_Turnover_TTM = Column(float) #淨值週轉率
#     Fixed_Asset_Turnover_TTM = Column(float) #固定資產週轉率
#     Days_Receivables_Outstanding_TTM = Column(float) #期末收帳天
    
#     Days_Payables_Outstanding_TTM = Column(float) #期末付帳天數
#     Days_Inventory_Outstanding_TTM = Column(float) #期末售貨天數
#     Net_Operating_Cycle_TTM = Column(float) #淨營業週期
#     Book_Value_Per_Share_A_TTM = Column(float) #每股淨值
#     Sales_Per_Share_TTM = Column(float) #每股營業收入
#     Operating_Income_Per_Share_TTM = Column(float) #每股營業利益
#     Pre_Tax_Income_Per_Share_TTM = Column(float) #每股稅前淨益
#     Net_Income_Per_Share_TTM = Column(float) #每股稅後淨利
#     Sales_Per_Employee_TTM = Column(float) #每人營收    
    
#     domain = TW_EQUITIES
        
  

   